;
; les procdures
;


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de gnration de nombres alatoires
; *
; * note : ici je n'ai pas utilis les valeurs que j'utilise habituellement, parcequ'elles font partie de ma
; * signature (et vous ne voudriez pas vous retrouver avec un procs sur le dos, non ?) alors j'en ai mis d'autres
; * qui devrait fonctionner...
; * si ce n'est pas le cas changez les... le systme employ permet un grand ventail de possibilits
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
;
; ici, ce sont les tmoins concernant les informations du microprocesseur
;

Temoins_Aptitudes_Du_MicroProcesseur	DWORD ?
; bit 0 = Cpuid support ? 1=oui, 0=non
; bit 1 = Fpu support ? 1=oui, 0=non
; bit 2 = Tsc support ? 1=oui, 0=non
; bit 3 = Cx8 support ? 1=oui, 0=non
; bit 4 = cMov support ? 1=oui, 0=non
; bit 5 = Clfsh support ? 1=oui, 0=non
; bit 6 = Mmx support ? 1=oui, 0=non
; bit 7 = Fxsr support ? 1=oui, 0=non
; bit 8 = Sse support ? 1=oui, 0=non
; bit 9 = Sse2 support ? 1=oui, 0=non
; bit 10 = Htt support ? 1=oui, 0=non
; bit 11 = Sse3 support ? 1=oui, 0=non
; bit 12 =


.CODE
ALIGN 16
;
; obtenir des informations sur le microprocesseur qui utilise le programme
;
; Rceptionne :
; rien
;
; Retourne :
; la variable Temoins_Aptitudes_Du_MicroProcesseur est dfinie avec les bits positionns
;
; Syntaxe : DefinirAptitudesDuProcesseur
;
DefinirAptitudesDuProcesseur PROC
		pushad									;; empiler tous les registres

		mov Temoins_Aptitudes_Du_MicroProcesseur,0		;; mise  0 de la variable
; l'instruction CPUID est supporte, seulement s'il est possible de positionner/enlever le flag ID (EFLAGS bit 21).
		pushfd									;; ) copier les flags+flags etendus dans eax et edx
		pop eax									;; )
		mov edx,eax								;; )
		xor eax,200000h							;; inverser le flag ID
		push eax									;; ) et recopier le rsultat dans les flags
		popfd									;; )
		pushfd									;;	) puis on recopie  nouveau les flags dans eax
		pop eax									;;	)
		cmp eax,edx								;; comparer le rsultat  notre prcdente sauvegarde
		je PasSupportCpuid							;; si c'est semblable, c'est que notre modif n'a eu aucun effet, alors aller PasSupportCpuid
		mov Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000000000001b	;; positionner le bit correspondant dans notre variable

; ici, l'instruction cpuid est supporte, on va donc s'en servir pour connaitre les aptitudes du processeur
;		mov eax,0									;; ici, on dtermine le type d'infos que l'on veut rcuprer
;		cpuid									;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
;												;; (eax contient le nombre d'entres cpuid maximales)

; ici, on passe aux informations suivantes
		mov eax,1									;; ici, on dtermine les infos les plus importantes (du moins pour la programmation)
		cpuid									;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
												;; (eax contient le type, le model,la famille,...)
												;; (edx contient les caractristiques disponibles)
; les instructions fpu sont disponibles ?
		bt edx,0									;; tester le bit 0
		jnc PasSupportFpu							;; si le flag carry n'est pas positionn, aller PasSupportFpu
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000000000010b	;; positionner le bit correspondant dans notre variable
PasSupportFpu:
; l'instruction rdtsc est disponible ?
		bt edx,4									;; tester le bit 4
		jnc PasSupportRdtsc							;; si le flag carry n'est pas positionn, aller PasSupportRdtsc
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000000000100b	;; positionner le bit correspondant dans notre variable
PasSupportRdtsc:
; l'instruction CmpXchg8b est disponible ?
		bt edx,8									;; tester le bit 8
		jnc PasSupportCmpXchg8b						;; si le flag carry n'est pas positionn, aller PasSupportCmpXchg8b
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000000001000b	;; positionner le bit correspondant dans notre variable
PasSupportCmpXchg8b:
; les instructions cmov sont disponibles ?
		bt edx,15									;; tester le bit 15
		jnc PasSupportCmov							;; si le flag carry n'est pas positionn, aller PasSupportCmov
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000000010000b	;; positionner le bit correspondant dans notre variable
PasSupportCmov:
; les instructions clfsh sont disponibles ?
		bt edx,19									;; tester le bit 19
		jnc PasSupportClfsh							;; si le flag carry n'est pas positionn, aller PasSupportClfsh
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000000100000b	;; positionner le bit correspondant dans notre variable
PasSupportClfsh:
; les instructions mmx sont disponibles ?
		bt edx,23									;; tester le bit 23
		jnc PasSupportMmx							;; si le flag carry n'est pas positionn, aller PasSupportMmx
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000001000000b	;; positionner le bit correspondant dans notre variable
PasSupportMmx:
; les instructions fxsr sont disponibles ?
		bt edx,24									;; tester le bit 24
		jnc PasSupportFxsr							;; si le flag carry n'est pas positionn, aller PasSupportFxsr
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000010000000b	;; positionner le bit correspondant dans notre variable
PasSupportFxsr:
; les instructions sse sont disponibles ?
		bt edx,25									;; tester le bit 25
		jnc PasSupportSse							;; si le flag carry n'est pas positionn, aller PasSupportSse
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000000100000000b	;; positionner le bit correspondant dans notre variable
PasSupportSse:
; les instructions sse2 sont disponibles ?
		bt edx,26									;; tester le bit 26
		jnc PasSupportSse2							;; si le flag carry n'est pas positionn, aller PasSupportSse2
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000001000000000b	;; positionner le bit correspondant dans notre variable
PasSupportSse2:
; les instructions htt sont disponibles ?
		bt edx,28									;; tester le bit 28
		jnc PasSupportHtt							;; si le flag carry n'est pas positionn, aller PasSupportHtt
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000010000000000b	;; positionner le bit correspondant dans notre variable
PasSupportHtt:
; les instructions sse3 sont disponibles ?
		bt ecx,0									;; tester le bit 0
		jnc PasSupportSse3							;; si le flag carry n'est pas positionn, aller PasSupportSse3
		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000000100000000000b	;; positionner le bit correspondant dans notre variable
PasSupportSse3:
;; les instructions Xxx sont disponibles ?
;		bt edx,Xxx								;; tester le bit 
;		jnc PasSupportXxx							;; si le flag carry n'est pas positionn, aller
;		or Temoins_Aptitudes_Du_MicroProcesseur,0000000000000000001000000000000b	;; positionner le bit correspondant dans notre variable
;PasSupportXxx:

; ici, on passe aux informations suivantes
;		mov eax,2									;; ici, on dtermine les infos concernant le cache
;		cpuid									;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
PasSupportCpuid:
		popad									;; dsempiler tous les registres
	ret											;; retourner, sortir de la procdure
DefinirAptitudesDuProcesseur ENDP


.DATA
ALIGN 16
_Nombres_Aleatoires_		DWORD ?
.CODE
ALIGN 16
;
; Initialiser les nombres aleatoires avec le nombre de millisecondes coules depuis le dmarrage de l'ordinateur.
;
; Rceptionne :
; rien
;
; Retourne:
; eax = nombre de tick depuis le dmarrage de l'ordi. (mais surtout, la variable _Nombres_Aleatoires_ est dfinie)
;
; syntaxe : InitialiserNombresAleatoires
;
InitialiserNombresAleatoires PROC
		invoke GetTickCount							;; obtenir les millisecondes depuis le dmarrage
		test eax,eax								;; tester si eax = 0 (si c'est possible ! si vous lancez ce programme 48 jours aprs le dmarrage de l'ordinateur, lol)
		jnz Label1								;; si diffrent aller Label 1
		mov eax,123456789							;; mettre un nombre quelconque (pour eviter une division ultrieure par 0, suivant le gnrateur utilis)
Label1:	mov _Nombres_Aleatoires_,eax					;; sauver le rsultat pour initialiser les nombres alatoires
	ret											;; retourner (sortir de la procdure)
InitialiserNombresAleatoires ENDP


ALIGN 16
;
; generer un nombre aleatoire 32-bits entre 0 et une valeur maximale (exclue)
;
; Rceptionne :
; ebx = la valeur maximale +1 (ne peut pas tre zro, doit imprativement tre suprieur  1 pour une valeur
; situe dans un rang, ou 1 pour gnrer une valeur alatoire 32 bits)
;
; Retourne :
; eax = nombre aleatoire entre 0 et la valeur maximale (exclue), ou un nombre alatoire 32 bits si ebx = 1
;
; syntaxe : GenererNombreAleatoire
;
GenererNombreAleatoire PROC
		push edx									;; empiler edx

		mov eax,987654321							;; placer 987654321 dans eax
		mul _Nombres_Aleatoires_						;; multiplier eax par l'alatoire prcedent
		bswap eax									;; inverser l'ordre des octets pour rendre la valeur plus alatoire
		xor eax,078787878h							;; et pratiquer une inversion de bits (ne peut tre fait avec 0h ou FFFFFFFFh)
		jnz Label1								;; si c'est diffrent de 0, aller Label1
		mov eax,123456789							;; sinon, placer 123456789 dans eax
Label1:	mov _Nombres_Aleatoires_,eax					;; sauvegarder le nouveau nombre alatoire pour la gnration du prochain
; ici, on teste si c'est le cas d'une valeur alatoire 32 bits 
		cmp ebx,1									;; comparer ebx  1
		je Label2									;; si c'est le cas, c'est une valeur alatoire 32 bits, alors aller Label2
; ici, on traite le cas d'une valeur comprise entre 0 et X-1
		mul ebx									;; multiplier ensuite le nombre alatoire par la valeur maximale
		mov eax,edx								;; et placer le dpassement en eax
Label2:
		pop edx									;; dsempiler edx
	ret											;; retourner (sortir de la procdure)
GenererNombreAleatoire ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routine d'agrandissement * 2
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.CODE
ALIGN 16
;
; agrandir un cran (en multipliant sa taille par 2, avec un remplissage par fondu, sauf pour la dernire ligne) en version SSE
; l'cran originel doit tre multiple de 4 car les pixels sont, ici, traits par quatre
; videment, les deux blocs mmoire doivent avoir les tailles correspondantes... et doivent tre aligns sur 16 octets
;
; Rceptionne :
; esi = adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'cran originel
; edi = adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'ecran de destination
;
; retourne :
; rien
;
; syntaxe : Mmx_AgrandirX2_RemplissageFondu
;
Mmx_AgrandirX2_RemplissageFondu PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; placer la hauteur de l'cran originel dans ebx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer l'adresse du dbut de la zone originelle dans esi
		mov eax,(_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_	;; placer x._Largeur_Ecran_X4_
		mov edi,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_	;; placer l'adresse du dbut de la zone de destination dans edi
		mov ebp,eax								;; sauvegarder la valeur en eax (ca nous reservira aprs, a cause du manque de registres...)
		neg ebx									;; on inverse ebx, qui sera notre compteur de boucle pour les lignes
		pxor MM7,MM7								;; effacer MM7
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )
Label0:	mov ecx,eax								;; placer _Largeur_Ecran_Destination_X4_ dans ecx
		add edi,eax								;; ajouter _Largeur_Ecran_Destination_X4_ au pointeur destination
		shr ecx,1									;; on divise ensuite ecx par 2 pour avoir LargeurEcranOriginelX4 dans eax
		add esi,ecx								;; ajouter LargeurEcranOriginelX4 au pointeur source
		neg ecx									;; inverser ecx, qui sera notre compteur de boucle pour les colonnes
; ici, on traite la premire ligne
		movd MM0,DWORD PTR [ecx+esi]					;; placer la premire couleur dans MM0
		punpcklbw MM0,MM7							;; placer 00XX00XX00XX00XX dans MM0
Label1:	movd MM1,DWORD PTR [ecx+esi+4]				;; placer la deuxime couleur (qui servira  crer notre valeur casse) dans MM1
		movq MM2,MM0								;; recopier MM0 dans MM2
		punpcklbw MM1,MM7							;; placer 00XX00XX00XX00XX dans MM1
		paddw MM2,MM1								;; ajouter en parallle MM3  MM2
		psrlw MM2,1								;; diviser en parallle les words en MM2 par 2 (par un dcalage  droite de 2 bits)
		packuswb MM0,MM2							;; compacter les words de MM0 et MM2 en octets dans MM0
		movq QWORD PTR [2*ecx+edi],MM0				;; et recopier la premire couleur (inchange) + notre valeur casse dans edi+(ecx*2)
		movq MM0,MM1								;; recopier MM1 (la deuxime couleur qui devient la premire) dans MM0
		add ecx,4									;; augmenter ecx d'1 dword
		jnz Label1								;; tant que ecx est diffrent de 0, aller Label1
		add edi,eax								;; ajouter _Largeur_Ecran_Destination_X4_ au pointeur destination (puisqu'un ajout  dja t fait)
		inc ebx									;; incrmener ebx d'une ligne
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )

; maintenant que la premire ligne a t calcule, on va pouvoir calculer les lignes intermediaires en plus...
Label2:	mov ecx,ebp								;; placer _Largeur_Ecran_Destination_X4_ dans ecx
		mov eax,edi								;; copier edi dans eax
		mov edx,edi								;; copier edi dans edx
		sub eax,ecx								;; enlever une ligne destination  eax
		add edi,ecx								;; ajouter une ligne destination  edi
		shr ecx,1									;; on divise ensuite ecx par 2 pour avoir LargeurEcranOriginelX4 dans eax
		add esi,ecx								;; ajouter LargeurEcranOriginelX4 au pointeur source
		neg ecx									;; inverser ecx, qui sera notre compteur de boucle pour les colonnes

; ici, on traite les premires lignes
		movd MM0,DWORD PTR [ecx+esi]					;; placer la premire couleur dans MM0
		punpcklbw MM0,MM7							;; placer 00XX00XX00XX00XX dans MM0
Label3:	movd MM1,DWORD PTR [ecx+esi+4]				;; placer la deuxime couleur (qui servira  crer notre valeur casse) dans MM1
		punpcklbw MM1,MM7							;; placer 00XX00XX00XX00XX dans MM1
		movq MM2,MM0								;; recopier MM0 dans MM2
		movq MM3,MM0								;; recopier MM0 dans MM3 ) ca nous servira pour les lignes intermdiaires
		movq MM4,MM1								;; recopier MM1 dans MM4 )
		paddw MM2,MM1								;; ajouter en parallle MM3  MM2
		psrlw MM2,1								;; diviser en parallle les words en MM2 par 2 (par un dcalage  droite de 2 bits)
		packuswb MM0,MM2							;; compacter les words de MM0 et MM2 en octets dans MM0
		movq QWORD PTR [2*ecx+edi],MM0				;; et recopier la premire couleur (inchange) + notre valeur casse dans edi+(ecx*2)

; ici, on traite les deuximes lignes
		movq MM5,QWORD PTR [2*ecx+eax]				;; placer le qword de 2 lignes avant dans MM5
		movq MM0,MM1								;; recopier MM1 (la deuxime couleur qui devient la premire) dans MM0
		movq MM6,MM5								;; recopier MM5 dans MM6
		punpcklbw MM5,MM7							;; placer 00XX00XX00XX00XX dans MM5
		punpckhbw MM6,MM7							;; placer 00XX00XX00XX00XX dans MM6
		paddw MM3,MM5								;; ajouter en parallle MM5  MM3
		paddw MM4,MM6								;; ajouter en parallle MM6  MM4
		psrlw MM3,1								;; diviser en parallle les words en MM3 par 2 (par un dcalage  droite de 2 bits)
		psrlw MM4,1								;; diviser en parallle les words en MM4 par 2 (par un dcalage  droite de 2 bits)
		packuswb MM3,MM4							;; compacter les words de MM3 et MM4 en octets dans MM3
		movq QWORD PTR [2*ecx+edx],MM3				;; et recopier les deux couleurs casses dans edx+(ecx*2) (la ligne prcdente)
Label4:	add ecx,4									;; augmenter ecx d'1 dword
		jnz Label3								;; tant que ecx est diffrent de 0, aller Label3
		add edi,ebp								;; ajouter _Largeur_Ecran_Destination_X4_ au pointeur destination (puisqu'un ajout  dja t fait)
		inc ebx									;; incrmener ebx d'une ligne
		jnz Label2								;; tant que ebx est diffrent de 0, aller Label2

; enfin, on double la dernire ligne (parceque je vois pas quoi faire d'autre...)
		mov ecx,ebp								;; placer _Largeur_Ecran_Destination_X4_ dans ecx
		mov esi,edi								;; copier edi dans esi
		sub esi,ecx								;; ajouter ecx  edi
		neg ecx									;; inverser ecx, qui sera notre compteur de boucle pour les colonnes
Label5:	movq MM0,QWORD PTR [ecx+esi]					;; placer le qword de la ligne prcdente dans MM0
		movq QWORD PTR [ecx+edi],MM0					;; et la recopier dans la dernire ligne
		add ecx,8									;; augmenter ecx d'1 qword
		jnz Label5								;; tant que ecx est diffrent de 0, aller Label5

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_AgrandirX2_RemplissageFondu ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routine d'effacement d'un bloc mmoire
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.CODE
ALIGN 16
;
; effacer un bloc memoire (en le remplissant de 0)
; note : MM0 est modifi
;
; Syntaxe :
; mov eax,{taille  ffacer en octets}
; mov edi,{adresse du bloc de destination}
; call Mmx_EffacerBlocMemoire
;
; Retourne :
; rien
;
Mmx_EffacerBlocMemoire PROC
		push ecx									;; empiler ecx

; ici on traite les 4x owords
		mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,11111111111111111111111111000000b		;; ne conserver que les bits 4x owords en ecx
		jz Label1									;; si ecx est gal  0, aller Label1
		add edi,ecx								;; on ajoute ecx  edi
		neg ecx									;; inverser ecx
		pxor MM0,MM0								;; effacer MM0
Label0:	movq QWORD PTR[edi+ecx],MM0					;; placer 0 en edi+ecx
		movq QWORD PTR[edi+ecx+8],MM0					;; placer 0 en edi+ecx+8
		movq QWORD PTR[edi+ecx+16],MM0				;; placer 0 en edi+ecx+16
		movq QWORD PTR[edi+ecx+24],MM0				;; placer 0 en edi+ecx+24
		movq QWORD PTR[edi+ecx+32],MM0				;; placer 0 en edi+ecx+32
		movq QWORD PTR[edi+ecx+40],MM0				;; placer 0 en edi+ecx+40
		movq QWORD PTR[edi+ecx+48],MM0				;; placer 0 en edi+ecx+48
		movq QWORD PTR[edi+ecx+56],MM0				;; placer 0 en edi+ecx+56
		add ecx,64								;; on ajoute 64  ecx (notre pas de boucle)
		jnz Label0								;; tant que ecx est diffrent de 0, aller Label0

; ici on traite les owords
Label1:	mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000110000b		;; ne conserver que les bits owords en ecx
		jz Label3									;; si ecx est gal  0, aller Label3
		add edi,ecx								;; on ajoute ecx  edi
		neg ecx									;; inverser ecx
		pxor MM0,MM0								;; effacer MM0
Label2:	movq QWORD PTR[edi+ecx],MM0					;; placer 0 en edi+ecx
		movq QWORD PTR[edi+ecx+8],MM0					;; placer 0 en edi+ecx+8
		add ecx,16								;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label2								;; tant que ecx est diffrent de 0, aller Label2

; ici on traite les dwords
Label3:	mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000001100b		;; ne conserver que les bits dwords en ecx
		jz Label5									;; si ecx est gal  0, aller Label5
		add edi,ecx								;; on ajoute ecx  edi
		neg ecx									;; inverser ecx
Label4:	mov DWORD PTR [edi+ecx],0					;; placer 0 en edi+ecx
		add ecx,4									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label4								;; tant que ecx est diffrent de 0, aller Label4

; ici on traite les octets
Label5:	mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,00000000000000000000000000000011b		;; ne conserver que les bits octets en ecx
		jz Label7									;; si ecx est gal  0, aller Label7
		add edi,ecx								;; on ajoute ecx  edi
		neg ecx									;; inverser ecx
Label6:	mov BYTE PTR [edi+ecx],0						;; placer 0 en edi+ecx
		inc ecx									;; on ajoute 1  ecx (notre pas de boucle)
		jnz Label6								;; tant que ecx est diffrent de 0, aller Label6
Label7:	sub edi,eax								;; soustraire la taille  edi (pour retrouver l'adresse originelle)

		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
Mmx_EffacerBlocMemoire ENDP


ALIGN 16
;
; casser les couleurs d'un bloc memoire (en les fusionnant avec une autre couleur)
; note : MM5,MM6 et MM7 sont modifis
;
; Rceptionne :
; eax = taille  ffacer en octets
; ebx = couleur qui va servir pour casser celle du bloc
; esi = adresse du bloc de destination
;
; Retourne :
; rien
;
; syntaxe : Mmx_CasserCouleurs
;
Mmx_CasserCouleurs PROC
		push ecx									;; empiler ecx

		movd MM6,ebx								;; placer la couleur dans MM6
		pxor MM7,MM7								;; effacer MM7
		punpcklbw MM6,MM7							;; placer 00XX00XX00XX00XX dans MM6
; ici on traite les 4x owords
		mov ecx,eax								;; placer la taille  copier dans ecx
		and ecx,11111111111111111111111111111100b		;; ne conserver que les bits 4x owords en ecx
		jz Label1									;; si ecx est gal  0, aller Label1
		add esi,ecx								;; on ajoute ecx  esi
		neg ecx									;; inverser ecx
Label0:	movd MM5,DWORD PTR[esi+ecx]					;; placer la couleur de fond dans MM5
		punpcklbw MM5,MM7							;; placer 00XX00XX00XX00XX dans MM6
		paddw MM5,MM6								;; ajouter en parallle MM6  MM5
		psrlw MM5,1								;; diviser en parallle les words en MM5 par 2 (par un dcalage  droite de 2 bits)
		packuswb MM5,MM7							;; compacter les words de MM5 et MM7 en octets dans MM5
		movd DWORD PTR [esi+ecx],MM5					;; et recopier la couleur (change)
		add ecx,4									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label0								;; tant que ecx est diffrent de 0, aller Label0
; ici on ne traite pas les octets (puisqu'une couleur correspond  1 dword)
Label1:	sub esi,eax								;; soustraire la taille  esi (pour retrouver l'adresse originelle)

		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
Mmx_CasserCouleurs ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * 4 routines d'effet fondu
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.CODE
ALIGN 16
;
; crer un effet blur montant sur un cran (le traitement doit se faire par dword sinon le rsultat est moins probant)
;
; Rceptionne :
; esi = adresse d'une structure _Bloc_Memoire_Ecran_ (adresse du tampon cran)
;
; Retourne :
; rien
;
; syntaxe : Mmx_EffetFonduAscendant
;
Mmx_EffetFonduAscendant PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer la largeur de l'cran multiplie par 4 dans eax
		mov ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; placer la hauteur de l'cran dans ebx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer le pointeur du tampon dans esi
		neg ebx									;; inverser ebx (qui devient notre compteur de boucle pour le nombre de lignes)

; ici, c'est un travail qui n'est effectu qu'une seule fois
		pxor MM7,MM7								;; effacer MM7 (plac ici, pour une question de vitesse)
		movd MM3,DWORD PTR [esi-DWORD]				;; placer le dword en esi dans MM3
		movd MM2,DWORD PTR [esi]						;; placer le dword en esi dans MM2
		punpcklbw MM3,MM7							;; entrelacer les octets suprieurs de MM3 et MM7
		punpcklbw MM2,MM7							;; entrelacer les octets suprieurs de MM2 et MM7

; ici, commence la boucle pour les lignes
Label1:	mov ecx,eax								;; placer le nombre de pixels en largeur x4 dans ecx (on a multipli par 4 parcequ'on va traiter par dwords)
		add esi,eax								;; on ajoute le rsultat  esi
		mov edi,esi								;; copier esi dans edi
		add edi,eax								;; ajouter _Largeur_Ecran_X4_  edi
		neg ecx									;; et on inverse ecx qui deviendra notre pas de boucle pour la largeur  traiter

; ici, commence la boucle pour une ligne
Label2:	movd MM1,DWORD PTR [esi+ecx+DWORD]				;; placer le dword en esi dans MM1
		movd MM0,DWORD PTR [edi+ecx]					;; placer le dword en esi dans MM0
		punpcklbw MM1,MM7							;; entrelacer les octets infrieurs de MM1 et MM7
		punpcklbw MM0,MM7							;; entrelacer les octets infrieurs de MM0 et MM7
; faire la somme des valeurs
		paddw MM0,MM3								;; ajouter en parallle MM3  MM0
		paddw MM0,MM2								;; ajouter en parallle MM2  MM0
		paddw MM0,MM1								;; ajouter en parallle MM1  MM0
; transfert de donnes pour eviter de les relire et de refaire des entrelacements
		movq MM3,MM2								;; on transfert MM2 dans MM3
		movq MM2,MM1								;; on transfert MM1 dans MM2
; diviser la sommes par le nombre de valeurs
		psrlw MM0,2								;; diviser en parallle les words en MM0 par 4 (par un dcalage  droite de 2 bits)
		packuswb MM0,MM7							;; compacter les words en octets dans MM0
		movd DWORD PTR [esi+ecx],MM0					;; placer le rsultat en MM0  l'adresse en esi
		add ecx,4									;; augmenter l'adresse (notre pas de boucle) d'1 dword
		jnz Label2								;; tant que ecx est diffrent de 0, retourner Label2
		inc ebx									;; augmenter l'adresse (notre pas de boucle) d'1 ligne
		jnz Label1								;; tant que ebx est diffrent de 0, retourner Label1

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_EffetFonduAscendant ENDP


ALIGN 16
;
; crer un effet blur descendant sur un cran (le traitement doit se faire par dword sinon le rsultat est moins probant)
;
; Rceptionne :
; esi = adresse d'une structure _Bloc_Memoire_Ecran_ (adresse du tampon cran)
;
; Retourne :
; rien
;
; syntaxe : Mmx_EffetFonduDescendant
;
Mmx_EffetFonduDescendant PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer la largeur de l'cran multiplie par 4 dans eax
		mov ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; placer la hauteur de l'cran dans ebx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer le pointeur du tampon dans esi
		neg ebx									;; inverser ebx (qui devient notre compteur de boucle pour le nombre de lignes)

; ici, c'est un travail qui n'est effectu qu'une seule fois
		pxor MM7,MM7								;; effacer MM7 (plac ici, pour une question de vitesse)
		movd MM3,DWORD PTR [esi-DWORD]				;; placer le dword en esi dans MM3
		movd MM2,DWORD PTR [esi]						;; placer le dword en esi dans MM2
		punpcklbw MM3,MM7							;; entrelacer les octets infrieurs de MM3 et MM7
		punpcklbw MM2,MM7							;; entrelacer les octets infrieurs de MM2 et MM7

; ici, commence la boucle pour les lignes
Label1:	mov ecx,eax								;; placer le nombre de pixels en largeur x4 dans ecx (on a multipli par 4 parcequ'on va traiter par dwords)
		mov edi,esi								;; copier esi dans edx
		add esi,eax								;; on ajoute le rsultat  esi
		neg ecx									;; et on inverse ecx qui deviendra notre pas de boucle pour la largeur  traiter

; ici, commence la boucle pour une ligne
Label2:	movd MM1,DWORD PTR [esi+ecx+DWORD]				;; placer le dword en esi dans MM1
		movd MM0,DWORD PTR [edi+ecx]					;; placer le dword en esi dans MM0
		punpcklbw MM1,MM7							;; entrelacer les octets suprieurs de MM1 et MM7
		punpcklbw MM0,MM7							;; entrelacer les octets suprieurs de MM0 et MM7
; faire la somme des valeurs
		paddw MM0,MM3								;; ajouter en parallle MM3  MM0
		paddw MM0,MM2								;; ajouter en parallle MM2  MM0
		paddw MM0,MM1								;; ajouter en parallle MM1  MM0
; transfert de donnes pour eviter de les relire et de refaire des entrelacements
		movq MM3,MM2								;; on transfert MM2 dans MM3
		movq MM2,MM1								;; on transfert MM1 dans MM2
; diviser la sommes par le nombre de valeurs
		psrlw MM0,2								;; diviser en parallle les words en MM0 par 4 (par un dcalage  droite de 2 bits)
		packuswb MM0,MM7							;; compacter les words en octets dans MM0
		movd DWORD PTR [esi+ecx],MM0					;; placer le rsultat en MM0  l'adresse en esi
		add ecx,4									;; augmenter l'adresse (notre pas de boucle) d'1 dword
		jnz Label2								;; tant que ecx est diffrent de 0, retourner Label2
		inc ebx									;; augmenter l'adresse (notre pas de boucle) d'1 ligne
		jnz Label1								;; tant que ebx est diffrent de 0, retourner Label1

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_EffetFonduDescendant ENDP


ALIGN 16
;
; crer un effet blur leger sur un cran (le traitement doit se faire par dword sinon le rsultat est moins probant)
;
; Rceptionne :
; esi = adresse d'une structure _Bloc_Memoire_Ecran_ (adresse du tampon cran)
;
; Retourne :
; rien
;
; syntaxe : Mmx_EffetFonduLeger
;
Mmx_EffetFonduLeger PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer la largeur de l'cran multiplie par 4 dans eax
		mov ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; placer la hauteur de l'cran dans ebx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer le pointeur du tampon dans esi
		neg ebx									;; inverser ebx (qui devient notre compteur de boucle pour le nombre de lignes)

; ici, c'est un travail qui n'est effectu qu'une seule fois
		pxor MM7,MM7								;; effacer MM7 (plac ici, pour une question de vitesse)
		movd MM1,DWORD PTR [esi-DWORD]				;; placer le dword en esi dans MM1 (n'est effectu qu'une seule fois)
		punpcklbw MM1,MM7							;; entrelacer les octets infrieurs de MM1 et MM7

; ici, commence la boucle pour les lignes
Label1:	mov ecx,eax								;; placer le nombre de pixels en largeur x4 dans ecx (on a multipli par 4 parcequ'on va traiter par dwords)
		add esi,eax								;; et l'ajouter  esi
		neg ecx									;; et on inverse ecx qui deviendra notre pas de boucle pour la largeur  traiter

; ici, commence la boucle pour une ligne
Label2:	movd MM0,DWORD PTR [esi+ecx]					;; placer le dword en esi dans MM0
		movd MM2,DWORD PTR [esi+ecx+DWORD]				;; placer le dword en esi dans MM2
; transformer les octets en words
		punpcklbw MM0,MM7							;; entrelacer les octets infrieurs de MM0 et MM7
		punpcklbw MM2,MM7							;; entrelacer les octets suprieurs de MM2 et MM7
; faire la somme des valeurs, et diviser la sommes par le nombre de valeurs
		paddw MM0,MM1								;; ajouter en parallle MM1  MM0
		paddw MM0,MM2								;; ajouter en parallle MM2  MM0
		movq MM2,MM0								;; copier MM0 dans MM2
		psrlw MM2,4								;; diviser en parallle les words en MM2 par 16 pour obtenir 0.25 du MM0 que l'on va calculer
		psrlw MM0,2								;; diviser en parallle les words en MM0 par 4 (par un dcalage  droite de 2 bits)
		paddw MM0,MM2								;; ajouter le rsultat en MM2  MM0 (cette bidouille n'est pas top pour le respect des couleurs... mais c'est relativement rapide)
		movq MM1,MM0								;; transferer MM0 dans MM1 (ce qui vitera de le relire)
		packuswb MM0,MM7							;; compacter les words en octets dans MM0
		movd DWORD PTR [esi+ecx],MM0					;; placer le rsultat en MM0  l'adresse en esi
		add ecx,4									;; augmenter l'adresse (notre pas de boucle) d'1 dword
		jnz Label2								;; tant que ecx est diffrent de 0, retourner Label2
		inc ebx									;; augmenter l'adresse (notre pas de boucle) d'1 ligne
		jnz Label1								;; tant que ebx est diffrent de 0, retourner Label1

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_EffetFonduLeger ENDP


ALIGN 16
;
; crer un effet blur statique sur un cran (le traitement doit se faire par dword sinon le rsultat est moins probant)
;
; Rceptionne :
; esi = adresse d'une structure _Bloc_Memoire_Ecran_ (adresse du tampon cran)
;
; Retourne :
; rien
;
; syntaxe : Mmx_EffetFonduStatique
;
Mmx_EffetFonduStatique PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer la largeur de l'cran multiplie par 4 dans eax
		mov ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; placer la hauteur de l'cran dans ebx
		mov esi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; placer le pointeur du tampon dans esi
		neg ebx									;; inverser ebx (qui devient notre compteur de boucle pour le nombre de lignes)

; ici, c'est un travail qui n'est effectu qu'une seule fois
		pxor MM7,MM7								;; effacer MM7 (plac ici, pour une question de vitesse)
		movd MM1,DWORD PTR [esi-DWORD]				;; placer le dword en esi dans MM1 (n'est effectu qu'une seule fois)
		punpcklbw MM1,MM7							;; entrelacer les octets infrieurs de MM1 et MM7

; ici, commence la boucle pour les lignes
Label1:	mov ecx,eax								;; placer le nombre de pixels en largeur x4 dans ecx (on a multipli par 4 parcequ'on va traiter par dwords)
		mov edx,esi								;; copier esi dans edx
		add esi,eax								;; on ajoute le rsultat  esi
		mov edi,esi								;; copier esi dans edi
		add edi,eax								;; ajouter _Largeur_Ecran_X4_  edi
		neg ecx									;; et on inverse ecx qui deviendra notre pas de boucle pour la largeur  traiter

; ici, commence la boucle pour une ligne
Label2:	movd MM0,DWORD PTR [esi+ecx+DWORD]				;; placer le dword en esi dans MM0
		movd MM2,DWORD PTR [edx+ecx]					;; placer le dword en esi dans MM2
		movd MM3,DWORD PTR [edi+ecx]					;; placer le dword en esi dans MM3
; transformer les octets en words
		punpcklbw MM0,MM7							;; entrelacer les octets infrieurs de MM0 et MM7
		punpcklbw MM2,MM7							;; entrelacer les octets suprieurs de MM2 et MM7
		punpcklbw MM3,MM7							;; entrelacer les octets suprieurs de MM3 et MM7
; faire la somme des valeurs
		paddw MM0,MM1								;; ajouter en parallle MM1  MM0
		paddw MM0,MM2								;; ajouter en parallle MM2  MM0
		paddw MM0,MM3								;; ajouter en parallle MM3  MM0
; diviser la sommes par le nombre de valeurs
		psrlw MM0,2								;; diviser en parallle les words en MM0 par 4 (par un dcalage  droite de 2 bits)
		movq MM1,MM0								;; transferer MM0 dans MM1 (ce qui vitera de le relire)
		packuswb MM0,MM7							;; compacter les words en octets dans MM0
		movd DWORD PTR [esi+ecx],MM0					;; placer le rsultat en MM0  l'adresse en esi
		add ecx,4									;; augmenter l'adresse (notre pas de boucle) d'1 dword
		jnz Label2								;; tant que ecx est diffrent de 0, retourner Label2
		inc ebx									;; augmenter l'adresse (notre pas de boucle) d'1 ligne
		jnz Label1								;; tant que ebx est diffrent de 0, retourner Label1

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_EffetFonduStatique ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de gestion mmoire/crans (c'est relativement la mme chose...)
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.CODE
ALIGN 16
;
; allouer un cran (bloc mmoire)  un pointeur (ce bloc est align sur 16 octets)
; note : la structure _Informations_Memoire_ doit, videment, avoir t au pralable cre et dfinie
;
; Rceptionne :
; eax = largeur de l'cran (en pixels)
; ebx = hauteur de l'cran (en pixels)
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_Ecran_ (ce sera le tampon de l'cran)
;
; retourne :
; eax = adresse du bloc mmoire align
; et les variables x._Pointeur_, x._Pointeur_A_Liberer_, x._Taille_Du_Bloc_, x._Largeur_Ecran_, x.Hauteur_Ecran_,
; et x._Largeur_Ecran_X4_ sont dfinies
;
; syntaxe : CreerEcran
;
CreerEcran PROC
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_,eax	;; placer eax dans x._Largeur_Ecran_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Hauteur_Ecran_,ebx	;; placer eax dans x._Hauteur_Ecran_
		shl eax,2									;; multiplier la largeur par 4
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Largeur_Ecran_X4_,eax	;; placer eax dans x._Largeur_Ecran_X4_
		mul ebx									;; multiplier _Largeur_Ecran_X4_ par _Hauteur_Ecran_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Taille_Du_Bloc_,eax	;; placer eax dans x._Taille_Du_Bloc_
		add eax,16								;; ajouter 16  la taille, ce qui servira pour aligner le bloc mmoire sur 16 octets
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax	;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_A_Liberer_,eax	;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h							;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h							;; )
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_,eax	;; sauvegarder eax dans x._Pointeur_
		mov (_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_Zbuffer_,eax	;; sauvegarder eax dans x._Pointeur_Zbuffer_ (ca vite des dsagrments de mauvaise utilisation CreerEcran/CreerEcranAvecZBuffer)

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
CreerEcran ENDP


ALIGN 16
;
; crer l'instance mmoire (ce qui doit tre fait, une fois, avant de pouvoir allouer des blocs mmoires)
; note : normalement (sauf cas exceptionnels) une seule instance suffit pour l'ensemble de votre programme
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
;
; retourne :
; eax = l'adresse de l'instance
; et les variables x._Instance_, x._Taille_Initiale_ et x._Taille_Maximale_ sont dfinies
;
; syntaxe : CreerInstanceMemoire
;
CreerInstanceMemoire PROC
		push eax									;; empiler eax
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		invoke HeapCreate,HEAP_NO_SERIALIZE,(_Informations_Memoire_ PTR [esi])._Taille_Initiale_,(_Informations_Memoire_ PTR [esi])._Taille_Maximale_	;; cr une instance mmoire, et defini des valeurs mmoire
		mov (_Informations_Memoire_ PTR [esi])._Instance_,eax	;; sauvegarde du pointeur de l'instance

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
CreerInstanceMemoire ENDP


ALIGN 16
;
; allouer un bloc mmoire  un pointeur (ce bloc est align sur 16 octets)
; note : la structure _Informations_Memoire_ doit, videment, avoir t au pralable cre et dfinie
;
; Rceptionne :
; eax = taille du bloc mmoire que l'on va crer (en octets)
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_
;
; retourne :
; eax = adresse du bloc mmoire alig
; et les variables x._Pointeur_, x._Pointeur_A_Liberer_ et x._Taille_Du_Bloc_ sont dfinies
;
; syntaxe : AllouerBlocMemoire
;
AllouerBlocMemoire PROC
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		mov (_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,eax	;; placer eax dans x._Taille_Du_Bloc_
		add eax,000000010h							;; ajouter 16  la taille, ce qui servira pour aligner le bloc mmoire sur 16 octets
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax	;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_,eax	;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h							;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h							;; )
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_,eax	;; sauvegarder eax dans x._Pointeur_

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
AllouerBlocMemoire ENDP


ALIGN 16
;
; librer un bloc mmoire
; note : si il n'y a pas d'autres bloc mmoire, ne pas oublier de supprimer l'intance mmoire
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_
;
; retourne :
; rien
;
; syntaxe : LibererBlocMemoire
;
LibererBlocMemoire PROC
		push eax									;; empiler eax
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		invoke HeapFree,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE,(_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_	;; librer le bloc mmoire correspondant au pointeur

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
LibererBlocMemoire ENDP


ALIGN 16
;
; librer un cran (bloc mmoire)
; note : si il n'y a pas d'autres bloc mmoire, ne pas oublier de supprimer l'intance mmoire
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_Ecran_
;
; retourne :
; rien
;
; syntaxe : SupprimerEcran
;
SupprimerEcran PROC
		push eax									;; empiler eax
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		invoke HeapFree,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE,(_Bloc_Memoire_Ecran_ PTR [edi])._Pointeur_A_Liberer_	;; librer le bloc mmoire correspondant au pointeur

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
SupprimerEcran ENDP


ALIGN 16
;
; supprimer l'instance mmoire (ce qui doit tre fait avant de sortir de l'application, si une instance  t cre)
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
;
; retourne :
; rien
;
; syntaxe : SupprimerInstanceMemoire
;
SupprimerInstanceMemoire PROC
		push eax									;; empiler eax
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		invoke HeapDestroy,(_Informations_Memoire_ PTR [esi])._Instance_	;; librer l'instance mmoire

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
SupprimerInstanceMemoire ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de redimensionnement (autre que *2)
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Largeur_Ecran_			DWORD ?
_Hauteur_Ecran_			DWORD ?
_Largeur_Ecran_Originel_		DWORD ?
_Hauteur_Ecran_Originel_		DWORD ?
.CODE
ALIGN 16
;
; crer et dfinir une table, pour retailler (changer l'echelle, pour eviter des multiplications et
; divisions multiples pendant le redimensionnement)
; note : ne pas oublier de supprimer la table de redimensionnement prcdente (s'il y en a une)
; avant d'en crer une nouvelle (le cumul injustifi causera un crash)
; et videment, il faut s'assurer qu'une instance mmoire a t cre
;
; Rceptionne :
; eax = largeur de l'cran que l'on veut obtenir (en pixels) (la largeur obtenue par DefinirTailleDeRedimensionnement si ca doit tre proportionnel)
; ebx = hauteur de l'cran que l'on veut obtenir (en pixels) (la hauteur obtenue par DefinirTailleDeRedimensionnement si ca doit tre proportionnel)
; ecx = largeur de l'cran originel (en pixels)
; edx = hauteur de l'cran originel (en pixels)
; esi = adresse (offset) d'une structure _Informations_Memoire_ (parcequ'on en a besoin)
; edi = adresse (offset) d'une structure _Bloc_Memoire_ (le tampon de la table)
;
; Retourne :
; rien
;
; syntaxe : DefinirTableDeRedimensionnement
;
DefinirTableDeRedimensionnement PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
; premirement on sauvegarde les entres, ca va reservir...
		mov _Largeur_Ecran_,eax						;; sauvegarder eax dans _Largeur_Ecran_
		mov _Hauteur_Ecran_,ebx						;; sauvegarder ebx dans _Hauteur_Ecran_
		mov _Largeur_Ecran_Originel_,ecx				;; sauvegarder ecx dans _Largeur_Ecran_Originel_
		mov _Hauteur_Ecran_Originel_,edx				;; sauvegarder edx dans _Hauteur_Ecran_Originel_
; puis on calcul la taille mmoire  allouer...
		shl eax,2									;; multiplier _Largeur_Ecran_ par 4 (1 dword)
		mul ebx									;; multiplier _Largeur_Ecran_*DWORD par _Hauteur_Ecran_
		mov (_Bloc_Memoire_ PTR [edi])._Taille_Du_Bloc_,eax	;; placer eax dans x._Taille_Du_Bloc_
		add eax,16								;; ajouter 16  la taille, ce qui servira pour aligner le bloc mmoire sur 16 octets
; on alloue l'espace mmoire (qui est en fait gal  la taille cran) pour la table ( ce sera la zone de substitution de valeur)
		invoke HeapAlloc,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax	;; la taille en octets du bloc mmoire  crer
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_,eax	;; sauvegarder eax dans x._Pointeur_A_Liberer_
		and eax,0FFFFFFF0h							;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h							;; )
		mov (_Bloc_Memoire_ PTR [edi])._Pointeur_,eax	;; sauvegarder eax dans x._Pointeur_
; maintenant on va remplir chaque valeur de la premire ligne de notre table de substitution par la position relative dans l'cran originel
		mov esi,eax								;; copier _Bloc_Memoire_Table_De_Redimensionnement_._Pointeur_ dans esi
		mov ebx,_Largeur_Ecran_						;; placer _Largeur_Ecran_ dans ebx
		xor ecx,ecx								;; effacer ecx
; ici, on calcule les valeurs de substitution de la largeur
Label1:	mov eax,ecx								;; copier ecx dans eax
		mul _Largeur_Ecran_Originel_					;; multiplier eax par _Largeur_Ecran_Originel_
		xor edx,edx								;; effacer edx (ncessaire pour la division qui suit)
		div ebx									;; diviser eax par _Largeur_Ecran_
		shl eax,2									;; multiplier le rsultat obtenu par 4 (parceque ca devra tre un dword)
		mov DWORD PTR [4*ecx+esi],eax					;; sauver le rsultat obtenu  l'adresse en _Bloc_Memoire_Table_De_Redimensionnement_._Pointeur_+(ecx*4)
		inc ecx									;; incrmenter le pas de boucle
		cmp ecx,ebx								;; comparer ecx  _Largeur_Ecran_
		jb Label1									;; tant que ecx est infrieur  _Largeur_Ecran_, aller Label1
; ici, la premire ligne est calcule, on va la recopier dans toutes les autres lignes
		shl ebx,2									;; multiplier ebx par 4
		mov edi,esi								;; recopier l'adresse en esi dans edi
		add edi,ebx								;; ajouter l'uivalent d'une ligne  edi
		mov eax,_Hauteur_Ecran_						;; placer _Hauteur_Ecran_ (le nombre de lignes) dans eax
		dec eax									;; enlever une ligne  eax (ben oui, on en a dja calcul une...)
		neg eax									;; inverser eax
; ici on traite les owords
Label2:	mov ecx,ebx								;; copier _Largeur_Ecran_ x4 dans ecx
		and ecx,11111111111111111111111111110000b		;; ne conserver que les bits owords en ecx
		jz Label4									;; si ecx est gal  0, aller Label4
		add esi,ecx								;; on ajoute ecx  esi
		add edi,ecx								;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx									;; inverser ecx
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
Label3:	mov edx,DWORD PTR [esi+ecx]					;; placer le dword en esi+ecx dans ebx
		mov DWORD PTR [edi+ecx],edx					;; placer le dword en edi+ecx
		mov edx,DWORD PTR [esi+ecx+4]					;; placer le dword en esi+ecx+4 dans edx
		mov DWORD PTR [edi+ecx+4],edx					;; placer le dword en edi+ecx+4
		mov edx,DWORD PTR [esi+ecx+8]					;; placer le dword en esi+ecx+8 dans ebx
		mov DWORD PTR [edi+ecx+8],edx					;; placer le dword en edi+ecx+8
		mov edx,DWORD PTR [esi+ecx+12]				;; placer le dword en esi+ecx+12 dans edx
		mov DWORD PTR [edi+ecx+12],edx				;; placer le dword en edi+ecx+12
		add ecx,16								;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label3								;; tant que ecx est diffrent de 0, aller Label3
; ici on traite les dwords
Label4:	mov ecx,ebx								;; copier _Largeur_Ecran_ x4 dans ecx
		and ecx,00000000000000000000000000001100b		;; ne conserver que les bits dwords en ecx
		jz Label6									;; si ecx est gal  0, aller Label6
		add esi,ecx								;; on ajoute ecx  esi
		add edi,ecx								;; et aussi  edi, (pour mettre les 2 adresses  jour)
		neg ecx									;; inverser ecx
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
Label5:	mov edx,DWORD PTR [esi+ecx]					;; placer le dword en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx					;; et le recopier en edi+ecx
		add ecx,4									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label5								;; tant que ecx est sign, aller Label5
; ici on ne traite pas les octets (car au minimum ce sont des dwords)
Label6:	sub esi,ebx								;; soustraire la ligne copie  esi (pour retrouver l'adresse originelle)
		inc eax									;; incrmenter eax
		jnz Label2								;; tant que eax est diffrent de 0, aller Label2
; ici, notre table est remplie de premires ligne, on initialise la boucle pour la hauteur
		xor ecx,ecx								;; mettre ecx  0
; ici, on calcule les valeurs de substitution de la hauteur
Label7:	mov eax,ecx								;; copier ecx dans eax
		mul _Hauteur_Ecran_Originel_					;; multiplier eax par _Hauteur_Ecran_Originel_
		xor edx,edx								;; effacer edx (ncessaire pour la division qui suit)
		div _Hauteur_Ecran_							;; diviser eax par _Hauteur_Ecran_
		mul _Largeur_Ecran_Originel_					;; multiplier le rsultat en eax par une largeur de ligne
		shl eax,2									;; on multiplie eax par 4 (comme ca on a multipli par Largeur de ligne x4)
; ici, la hauteur est dfinie, on l'ajoute sur toutes les valeurs de la ligne, on traite les owords
		mov edi,ebx								;; copier _Largeur_Ecran_ x4 dans edi
		and edi,11111111111111111111111111110000b		;; ne conserver que les bits owords en edi
		jz Label9									;; si edi est gal  0, aller Label9
		add esi,edi								;; on ajoute edi  esi
		neg edi									;; inverser edi
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
Label8:	add DWORD PTR [esi+edi],eax					;; placer le dword en esi+edi
		add DWORD PTR [esi+edi+4],eax					;; placer le dword en esi+edi+4
		add DWORD PTR [esi+edi+8],eax					;; placer le dword en esi+edi+8
		add DWORD PTR [esi+edi+12],eax				;; placer le dword en esi+edi+12
		add edi,16								;; on ajoute 16  edi (notre pas de boucle)
		jnz Label8								;; tant que edi est diffrent de 0, aller Label8
; ici on traite les dwords
Label9:	mov edi,ebx								;; copier _Largeur_Ecran_ x4 dans edi
		and edi,00000000000000000000000000001100b		;; ne conserver que les bits dwords en edi
		jz Label11								;; si edi est gal  0, aller Label11
		add esi,edi								;; on ajoute edi  esi
		neg edi									;; inverser edi
;		nop										;; ) alignement ncessaire pour un meilleur rendement
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
;		nop										;; )
Label10:	add DWORD PTR [esi+edi],eax					;; placer le dword en esi+edi
		add edi,4									;; on ajoute 4  edi (notre pas de boucle)
		jnz Label10								;; tant que edi est sign, aller Label10
; ici on ne traite pas les octets (car au minimum ce sont des dwords)
Label11:	inc ecx									;; incrmenter le pas de boucle
		cmp ecx,_Hauteur_Ecran_						;; comparer ecx  _Hauteur_Ecran_
		jb Label7									;; tant que ecx est infrieur  _Hauteur_Ecran_, aller Label7

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
DefinirTableDeRedimensionnement ENDP


ALIGN 16
;
; retailler un cran (en fait on va substituer des valeurs  d'autres, pour eviter des multiplications et divisions multiples)
; videment, une table doit, au pralable, avoir t dfinie par DefinirTableDeRedimensionnement
;
; Rceptionne :
; eax = adresse (offset) d'une structure _Bloc_Memoire_ (le tampon de la table)
; esi = adresse (offset) d'une structure _Bloc_Memoire_Ecran_ (le tampon de l'cran originel)
; edi = adresse (offset) d'une structure _Bloc_Memoire_Ecran_ (le tampon de l'cran final)
;
;
; Retourne :
; rien
;
; syntaxe : Redimensionner
;
Redimensionner PROC
		push ebx									;; empiler ebx
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		mov ebx,(_Bloc_Memoire_ PTR [eax])._Pointeur_	;; placer _Bloc_Memoire_Table_De_Redimensionnement_._Pointeur_ dans ebx
; ici, on traite les owords
		mov ecx,(_Bloc_Memoire_ PTR [eax])._Taille_Du_Bloc_	;; placer _Bloc_Memoire_Table_De_Redimensionnement_._Taille_Du_Bloc_ dans ecx
		and ecx,11111111111111111111111111110000b		;; ne conserver que les bits owords en ecx
		jz Label2									;; si ecx est gal  0, aller Label2
		add ebx,ecx								;; ajouter la taille au pointeur de la table
		add edi,ecx								;; ajouter la taille au pointeur destination
		neg ecx									;; inverser ecx
		nop										;; ) alignement ncessaire pour un meilleur rendement
Label1:	mov edx,DWORD PTR [ebx+ecx]					;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx					;; et la recopier dans edi+ecx 
		mov edx,DWORD PTR [ebx+ecx+4]					;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx+4],edx					;; et la recopier dans edi+ecx+4
		mov edx,DWORD PTR [ebx+ecx+8]					;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx+8],edx					;; et la recopier dans edi+ecx+8
		mov edx,DWORD PTR [ebx+ecx+12]				;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx+12],edx				;; et la recopier dans edi+ecx+12
		add ecx,16								;; augmenter ecx d'1 oword
		jnz Label1								;; tant que ecx est diffrent de 0, aller Label1
; ici, on traite les dwords
Label2:	mov ecx,(_Bloc_Memoire_ PTR [eax])._Taille_Du_Bloc_	;; placer _Bloc_Memoire_Table_De_Redimensionnement_._Taille_Du_Bloc_ dans ecx
		and ecx,00000000000000000000000000001100b		;; ne conserver que les bits owords en ecx
		jz Label4									;; si ecx est gal  0, aller Label4
		add ebx,ecx								;; ajouter la taille au pointeur de la table
		add edi,ecx								;; ajouter la taille au pointeur destination
		neg ecx									;; inverser ecx
Label3:	mov edx,DWORD PTR [ebx+ecx]					;; placer la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]					;; placer la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ecx],edx					;; et la recopier dans edi+ecx 
		add ecx,4									;; augmenter ecx d'1 dword
		jnz Label3								;; tant que ecx est diffrent de 0, aller Label3
; on ne traite pas les octets car il ne peut y avoir que des dwords (alpha,rouge,vert,bleu) au minimum
Label4:	sub edi,(_Bloc_Memoire_ PTR [eax])._Taille_Du_Bloc_	;; soustraire _Bloc_Memoire_Table_De_Redimensionnement_._Taille_Du_Bloc_ au pointeur destination (pour retrouver l'adresse originelle)

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop ebx									;; dsempiler ebx
	ret											;; retourner (sortir de la procdure)
Redimensionner ENDP


ALIGN 16
;
; supprimer une table de retaillage
; note : si il n'y a pas d'autres bloc mmoire, ne pas oublier de supprimer l'intance mmoire
;
; Rceptionne :
; esi = adresse (offset) d'une structure _Informations_Memoire_
; edi = adresse (offset) d'une structure _Bloc_Memoire_ (le tampon de la table)
;
; Retourne :
; rien
;
; syntaxe : SupprimerTableDeRedimensionnement
;
SupprimerTableDeRedimensionnement PROC
		push eax									;; empiler eax
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		invoke HeapFree,(_Informations_Memoire_ PTR [esi])._Instance_,HEAP_NO_SERIALIZE,(_Bloc_Memoire_ PTR [edi])._Pointeur_A_Liberer_	;; librer le bloc mmoire correspondant au pointeur

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
SupprimerTableDeRedimensionnement ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines graphiques 2D
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Ligne_Decalage_Y_					DWORD ?,?,?,?		;; (align 16) le dcalage  pratiquer sur l'axe Y
_Ligne_Ecart_Maximal_				DWORD ?,?,?,?		;; (align 16)
_Ligne_Couleur_De_La_Ligne_			DWORD ?,?,?,?		;; (align 16) couleur de la ligne
_Ligne_Mmx_Masque_Alpha_movd_	DWORD 0FF000000h,0FF000000h,0FF000000h,0FF000000h
_Ligne_Mmx_Masque_ARVB_unpck_	DWORD 000FF00FFh,000FF00FFh,000FF00FFh,000FF00FFh
; note : ici, toutes les variables sont alignes sur 16 octets pour une question de rapidit


.CODE
ALIGN 16
;
; dessiner une ligne de X1,Y1  X2,Y2, quelque soit la validit des valeurs (cette version considre que tous les
; alphas de la ligne ont la mme valeur, ce qui est gnralement le cas...)
; note : ici on utilise une table multiplicatrice, pour eviter d'utiliser la trs lente instruction div pour les
; divisions. la table  t vrifie pour toutes les valeurs  diviser de 0  4095, et de 2  4095 pour les
; diviseurs (0 et 1 ne pouvant logiquement pas tre traiter par la table)
;
; Rceptionne :
; eax = la coordonne X1 (position largeur en pixels)
; ebx = la coordonne Y1 (position hauteur en pixels)
; ecx = la coordonne X2 (position largeur en pixels)
; edx = la coordonne Y2 (position hauteur en pixels)
; esi = adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'cran
; edi = la couleur de la ligne (format A,R,V,B)
;
; Retourne :
; rien, (attention, tous les registres MMx sont modifis)
;
; syntaxe : Mmx_DessinerLigne_Alpha
;
Mmx_DessinerLigne_Alpha PROC

;
; ici, on teste si les points se situent bien dans l'cran, sinon on va effectuer d'autres tests...
;
		cmp eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_	;; comparer eax  la largeur
		jae Label12								;; si c'est suprieur ou gal, aller Label12
		cmp ecx,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_	;; comparer X2  x._Largeur_Ecran_
		jae Label12								;; si c'est suprieur ou gal, aller Label12
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; comparer ebx  la hauteur
		jae Label12								;; si c'est suprieur ou gal, aller Label12
		cmp edx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; comparer Y2  x._Hauteur_Ecran_
		jae Label12								;; si c'est suprieur ou gal, aller Label12
;ALIGN 16
;
; l, les 2 points sont situs dans l'cran, alors on fait dans la rapidit...
;
		movd MM6,edi								;; MM6 = A,R,V,B
		movd MM2,edi								;; MM2 = A,R,V,B
		pand MM2,QWORD PTR _Ligne_Mmx_Masque_Alpha_movd_	;; MM2 = A,0,0,0
		movq MM3,MM2								;; MM3 = A,0,0,0
		psrlq MM3,8								;; MM3 = 0,A,0,0
		psrlq MM2,24								;; MM2 = 0,0,0,A
		punpckldq MM2,MM2							;; MM2 = 0,0,0,A , 0,0,0,A
		por MM2,MM3								;; MM2 = 0,0,0,A , 0,A,0,A
		movq MM3,MM2								;; MM3 = 0,0,0,A , 0,A,0,A
		pxor MM3,QWORD PTR _Ligne_Mmx_Masque_ARVB_unpck_	;; MM3 = 0,M,0,M , 0,M,0,M
		pxor MM7,MM7								;; MM7 = 0,0,0,0 , 0,0,0,0
Label00:	pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
; premirement on sauvegarde la couleur (ce qui permettra d'utiliser le registre edi)
		cmp eax,ecx								;; comparer la coordonne X1  X2
		ja Label01								;; si X1 est suprieur  X2, aller Label01
; ici, eax est le plus  gauche, donc on n'change pas la position des points
		lea edi,[4*eax]							;; sauvegarder la coordonne X1 *4 dans edi
		sub ecx,eax								;; enlever X1  X2
		sub edx,ebx								;; enlever Y1  Y2
		mov ebp,edx								;; sauvegarder l'cart Y (Y2-Y1) dans ebp
		mov eax,ebx								;; placer Y1 dans eax
		mov ebx,ecx								;; placer l'cart X (X2-X1) dans ebx
		jmp Label02								;; aller Label02
; ici, ecx est le plus  gauche, donc on change la position des points (ce qui evitera les lignes "doubles" et le dcalage X sera automatiquement Positif)
Label01:	lea edi,[4*ecx]							;; sauvegarder la coordonne X1 (en fait X2) *4 dans edi
		sub eax,ecx								;; enlever X2  X1
		sub ebx,edx								;; enlever Y2  Y1
		mov ebp,ebx								;; sauvegarder l'cart Y (Y1-Y2) dans ebp
		mov ebx,eax								;; placer l'cart X (X1-X2) dans ebx
		mov eax,edx								;; placer Y1 (en fait Y2)
; ici, on defini le premier point (enfin... celui qui est le plus  gauche)
Label02:	mov ecx,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; placer x._Largeur_Ecran_X4_ dans ecx, pour obtenir un pas Y
		mul ecx									;; multiplier Y1 par x._Largeur_Ecran_X4_
		add edi,eax								;; ajouter Y1 * x._Largeur_Ecran_X4_  edi
		add edi,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; on ajoute  edi le pointeur de dbut du bloc mmoire (qui contient dsormais la position du point)
; ici, on dfini si le dcalage Y est ngatif ou positif
		mov eax,ebp								;; placer ebp dans eax
		test eax,eax								;; fixer les flags de eax
		jns Label03								;; si eax n'est pas sign, aller Label03
		neg eax									;; sinon, on inverse eax, pour obtenir un cart en hauteur positif
		neg ecx									;; inverser ecx (x._Largeur_Ecran_X4_), pour obtenir un pas Y ngatif
; ici, on sauvegarde le dcalage de ligne obtenu
Label03:	mov ebp,ecx								;; sauvegarder ecx dans ebp (cart Y * largeur ligne)
; ici,
; eax = cart en hauteur
; ebx = cart en largeur
; esi = adresse de la structure _Bloc_Memoire_Ecran_
; edi = adresse cran + position Y + position X

; ici, on dtermine laquelle des 2 boucles on va utiliser
		cmp eax,ebx								;; comparer eax  ebx
		ja Label07								;; si eax est suprieur, aller Label07
;
; ici, on traite le cas o la largeur est la plus importante
;
		mov ecx,ebx								;; copier ebx (l'cart en largeur) dans ecx
		test ecx,ecx								;; fixer les flags de ecx
		jz Label06								;; si ecx est gal  zro, aller Label06
		lea esi,[4*ebx]							;; placer ebx*4 dans esi, qui devient notre pas de boucle
		add edi,esi								;; ajouter esi  edi
		neg esi									;; inverser esi (qui devient notre pas de boucle)
		inc eax									;; incrmenter eax (pour compenser le dcalage occasionn par le 0)
;ALIGN 16
; dbut de la boucle
Label04:	movd MM0,DWORD PTR [edi+esi]					;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6								;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0					;; placer la couleur (le pixel)  l'adresse en edi+esi
; calcul des nouvelles coordonnes
		sub ecx,eax								;; soustraire l'cart en hauteur  ecx
		jns Label05								;; si c'est positif, aller Label05
		add ecx,ebx								;; sinon, ajouter l'cart en largeur  ecx
		add edi,ebp								;; ajouter ebp (cart Y * largeur ligne)  edi
Label05:	add esi,DWORD								;; augmenter esi de DWORD
		jnz Label04								;; tant que esi n'est pas gal  0, retourner Label04
; on place le dernier point
Label06:	movd MM0,DWORD PTR [edi]						;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6								;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi],MM0						;; placer la couleur (le pixel)  l'adresse en edi+esi
; enfin, on restaure les registres...
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
;
; ici, on traite le cas o la hauteur est la plus importante
;
Label07:	mov ecx,eax								;; copier eax (l'cart en hauteur) dans ecx
		imul ebp									;; multiplier eax par ebp (cart Y * largeur ligne) (sign car ebp peut tre ngatif)
		mov esi,eax								;; placer eax dans esi, qui va devenir notre pas de boucle
		mov eax,ecx								;; replacer l'cart en hauteur dans eax
		test ecx,ecx								;; fixer les flags de ecx
		jz Label10								;; si ecx est gal  zro, aller Label10
		add edi,esi								;; ajouter esi  edi
		neg esi									;; inverser esi (qui devient notre pas de boucle)
		inc ebx									;; incrmenter ebx (pour compenser le dcalage occasionn par le 0)
;ALIGN 16
; dbut de la boucle
Label08:	movd MM0,DWORD PTR [edi+esi]					;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6								;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0					;; placer la couleur (le pixel)  l'adresse en edi+esi
; calcul des nouvelles coordonnes
		sub ecx,ebx								;; soustraire l'cart en largeur  ecx
		jns Label09								;; si c'est positif, aller Label09
		add ecx,eax								;; sinon, ajouter l'cart en hauteur  ecx
		add edi,DWORD								;; ajouter DWORD  edi
Label09:	add esi,ebp								;; augmenter esi de ebp (cart Y * largeur ligne)
		jnz Label08								;; tant que esi n'est pas gal  0, retourner Label08
; on place le dernier point
Label10:	movd MM0,DWORD PTR [edi]						;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6								;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi],MM0						;; placer la couleur (le pixel)  l'adresse en edi+esi
; enfin, on restaure les registres...
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
Label11:
	ret											;; retourner (sortir de la procdure)


;
; ici, on va determiner s'il y a un travail  effectuer ou pas (si la ligne est compltement hors cran on sort)
;

; ici, on va effectuer une serie de test en fonction des positions X
Label12:	cmp eax,ecx								;; comparer eax  ecx
		jg Label14								;; si eax est suprieur sign, aller Label14
;
; ici, ecx >= eax
;
		bt ecx,31									;; tester le bit du signe de X2
		jc Label11								;; s'il est positionn (X1 et X2 < 0), aller Label11 (la sortie)
		cmp eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_	;; comparer X1  x._Largeur_Ecran_
		jge Label11								;; si c'est suprieure ou gale sign (X1 et X2 > largeur), aller Label11 (la sortie)
; ici, on va effectuer une serie de test en fonction des positions Y
		cmp ebx,edx								;; comparer ebx  edx
		jg Label13								;; si eax est infrieur sign, aller Label13

; ici, ecx >= eax et edx >= ebx
		bt edx,31									;; tester le bit du signe de Y2
		jc Label11								;; s'il est positionn (Y1 et Y2 < 0), aller Label11 (la sortie)
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; comparer Y1  x._Hauteur_Ecran_
		jge Label11								;; si c'est suprieure ou gale sign (Y1 et Y2 > hauteur), aller Label11 (la sortie)
; on initialise quelques valeurs
		movd MM6,edi								;; MM6 = A,R,V,B
		movd MM2,edi								;; MM2 = A,R,V,B
		pand MM2,QWORD PTR _Ligne_Mmx_Masque_Alpha_movd_	;; MM2 = A,0,0,0
		movq MM3,MM2								;; MM3 = A,0,0,0
		psrlq MM3,8								;; MM3 = 0,A,0,0
		psrlq MM2,24								;; MM2 = 0,0,0,A
		punpckldq MM2,MM2							;; MM2 = 0,0,0,A , 0,0,0,A
		por MM2,MM3								;; MM2 = 0,0,0,A , 0,A,0,A
		movq MM3,MM2								;; MM3 = 0,0,0,A , 0,A,0,A
		pxor MM3,QWORD PTR _Ligne_Mmx_Masque_ARVB_unpck_	;; MM3 = 0,M,0,M , 0,M,0,M
		pxor MM7,MM7								;; MM7 = 0,0,0,0 , 0,0,0,0
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
		mov ebp,esi								;; sauvegarder l'adresse de la structure _Bloc_Memoire_Ecran_ dans ebp
; ici, on teste si l'on doit calculer l'entre du point dans l'cran
		bt eax,31									;; tester le bit du signe de X1
		jc Label27								;; s'il est positionn (X1 < 0), aller Label27
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; comparer Y1  x._Hauteur_Ecran_
		jae Label27								;; si c'est suprieure ou gale (Y1 > 0 ou Y1 > hauteur), aller Label27
; ici, on n'change pas les positions et on saute  l'endroit appropri de l'algorythme
		mov esi,eax								;; sauvegarder la coordonne X1 dans esi
		shl esi,2									;; multiplier esi par 4, pour obtenir position X *4
		sub ecx,eax								;; enlever X1  X2
		sub edx,ebx								;; enlever Y1  Y2
		mov _Ligne_Decalage_Y_,edx					;; sauvegarder l'cart Y (Y2-Y1) dans _Ligne_Decalage_Y_
		mov eax,ebx								;; placer Y1 dans eax
		mov ebx,ecx								;; placer l'cart X (X2-X1) dans ebx
		jmp Label16								;; aller Label16

; ici, ecx >= eax et ebx > edx
Label13:	bt ebx,31									;; tester le bit du signe de Y1
		jc Label11								;; s'il est positionn (Y1 et Y2 < 0), aller Label11 (la sortie)
		cmp edx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; comparer Y2  x._Hauteur_Ecran_
		jge Label11								;; si c'est suprieure ou gale sign (Y1 et Y2 > hauteur), aller Label11 (la sortie)
; on initialise quelques valeurs
		movd MM6,edi								;; MM6 = A,R,V,B
		movd MM2,edi								;; MM2 = A,R,V,B
		pand MM2,QWORD PTR _Ligne_Mmx_Masque_Alpha_movd_	;; MM2 = A,0,0,0
		movq MM3,MM2								;; MM3 = A,0,0,0
		psrlq MM3,8								;; MM3 = 0,A,0,0
		psrlq MM2,24								;; MM2 = 0,0,0,A
		punpckldq MM2,MM2							;; MM2 = 0,0,0,A , 0,0,0,A
		por MM2,MM3								;; MM2 = 0,0,0,A , 0,A,0,A
		movq MM3,MM2								;; MM3 = 0,0,0,A , 0,A,0,A
		pxor MM3,QWORD PTR _Ligne_Mmx_Masque_ARVB_unpck_	;; MM3 = 0,M,0,M , 0,M,0,M
		pxor MM7,MM7								;; MM7 = 0,0,0,0 , 0,0,0,0
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
		mov ebp,esi								;; sauvegarder l'adresse de la structure _Bloc_Memoire_Ecran_ dans ebp
; ici, on teste si l'on doit calculer l'entre du point dans l'cran
		bt eax,31									;; tester le bit du signe de X1
		jc Label27								;; s'il est positionn (X1 < 0), aller Label27
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; comparer Y1  x._Hauteur_Ecran_
		jae Label27								;; si c'est suprieure ou gale (Y1 > 0 ou Y1 > hauteur), aller Label27
; ici, on n'change pas les positions et on saute  l'endroit appropri de l'algorythme
		mov esi,eax								;; sauvegarder la coordonne X1 dans esi
		shl esi,2									;; multiplier esi par 4, pour obtenir position X *4
		sub ecx,eax								;; enlever X1  X2
		sub edx,ebx								;; enlever Y1  Y2
		mov _Ligne_Decalage_Y_,edx					;; sauvegarder l'cart Y (Y2-Y1) dans _Ligne_Decalage_Y_
		mov eax,ebx								;; placer Y1 dans eax
		mov ebx,ecx								;; placer l'cart X (X2-X1) dans ebx
		jmp Label16								;; aller Label16

;
; ici, eax > ecx
;
Label14:	bt eax,31									;; tester le bit du signe de X1
		jc Label11								;; s'il est positionn (X1 et X2 < 0), aller Label11 (la sortie)
		cmp ecx,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_	;; comparer X2  x._Largeur_Ecran_
		jge Label11								;; si c'est suprieure ou gale sign (X1 et X2 > largeur), aller Label11 (la sortie)
; ici, on va effectuer une serie de test en fonction des positions Y
		cmp ebx,edx								;; comparer ebx  edx
		jg Label15								;; si ebx est suprieur sign, aller Label15

; ici, edx >= ebx
		bt edx,31									;; tester le bit du signe de Y2
		jc Label11								;; s'il est positionn (Y1 et Y2 < 0), aller Label11 (la sortie)
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; comparer Y1  x._Hauteur_Ecran_
		jge Label11								;; si c'est suprieure ou gale sign (Y1 et Y2 > hauteur), aller Label11 (la sortie)
; on initialise quelques valeurs
		movd MM6,edi								;; MM6 = A,R,V,B
		movd MM2,edi								;; MM2 = A,R,V,B
		pand MM2,QWORD PTR _Ligne_Mmx_Masque_Alpha_movd_	;; MM2 = A,0,0,0
		movq MM3,MM2								;; MM3 = A,0,0,0
		psrlq MM3,8								;; MM3 = 0,A,0,0
		psrlq MM2,24								;; MM2 = 0,0,0,A
		punpckldq MM2,MM2							;; MM2 = 0,0,0,A , 0,0,0,A
		por MM2,MM3								;; MM2 = 0,0,0,A , 0,A,0,A
		movq MM3,MM2								;; MM3 = 0,0,0,A , 0,A,0,A
		pxor MM3,QWORD PTR _Ligne_Mmx_Masque_ARVB_unpck_	;; MM3 = 0,M,0,M , 0,M,0,M
		pxor MM7,MM7								;; MM7 = 0,0,0,0 , 0,0,0,0
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
		mov ebp,esi								;; sauvegarder l'adresse de la structure _Bloc_Memoire_Ecran_ dans ebp
; ici, on teste si l'on doit calculer l'entre du point dans l'cran
		bt ecx,31									;; tester le bit du signe de X2
		jc Label27								;; s'il est positionn (X2 < 0), aller Label27
		cmp edx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; comparer Y2  x._Hauteur_Ecran_
		jae Label27								;; si c'est suprieure ou gale (Y2 > 0 ou Y2 > hauteur), aller Label27
; ici, on change les positions et on saute  l'endroit appropri de l'algorythme
		mov esi,ecx								;; sauvegarder la coordonne X1 (en fait X2) dans esi
		shl esi,2									;; multiplier esi par 4, pour obtenir position X *4
		sub eax,ecx								;; enlever X2  X1
		sub ebx,edx								;; enlever Y2  Y1
		mov _Ligne_Decalage_Y_,ebx					;; sauvegarder l'cart Y (Y1-Y2) dans _Ligne_Decalage_Y_
		mov ebx,eax								;; placer l'cart X (X1-X2) dans ebx
		mov eax,edx								;; placer Y1 (en fait Y2)
		jmp Label16								;; aller Label16

; ici, ebx > edx
Label15:	bt ebx,31									;; tester le bit du signe de Y1
		jc Label11								;; s'il est positionn (Y1 et Y2 < 0), aller Label11 (la sortie)
		cmp edx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; comparer Y2  x._Hauteur_Ecran_
		jge Label11								;; si c'est suprieure ou gale sign (Y1 et Y2 > hauteur), aller Label11 (la sortie)
; on initialise quelques valeurs
		movd MM6,edi								;; MM6 = A,R,V,B
		movd MM2,edi								;; MM2 = A,R,V,B
		pand MM2,QWORD PTR _Ligne_Mmx_Masque_Alpha_movd_	;; MM2 = A,0,0,0
		movq MM3,MM2								;; MM3 = A,0,0,0
		psrlq MM3,8								;; MM3 = 0,A,0,0
		psrlq MM2,24								;; MM2 = 0,0,0,A
		punpckldq MM2,MM2							;; MM2 = 0,0,0,A , 0,0,0,A
		por MM2,MM3								;; MM2 = 0,0,0,A , 0,A,0,A
		movq MM3,MM2								;; MM3 = 0,0,0,A , 0,A,0,A
		pxor MM3,QWORD PTR _Ligne_Mmx_Masque_ARVB_unpck_	;; MM3 = 0,M,0,M , 0,M,0,M
		pxor MM7,MM7								;; MM7 = 0,0,0,0 , 0,0,0,0
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
		mov ebp,esi								;; sauvegarder l'adresse de la structure _Bloc_Memoire_Ecran_ dans ebp
; ici, on teste si l'on doit calculer l'entre du point dans l'cran
		bt ecx,31									;; tester le bit du signe de X2
		jc Label27								;; s'il est positionn (X2 < 0), aller Label27
		cmp edx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; comparer Y2  x._Hauteur_Ecran_
		jae Label27								;; si c'est suprieure ou gale (Y2 > 0 ou Y2 > hauteur), aller Label27
; ici, on change les positions et on saute  l'endroit appropri de l'algorythme
		mov esi,ecx								;; sauvegarder la coordonne X1 (en fait X2) dans esi
		shl esi,2									;; multiplier esi par 4, pour obtenir position X *4
		sub eax,ecx								;; enlever X2  X1
		sub ebx,edx								;; enlever Y2  Y1
		mov _Ligne_Decalage_Y_,ebx					;; sauvegarder l'cart Y (Y1-Y2) dans _Ligne_Decalage_Y_
		mov ebx,eax								;; placer l'cart X (X1-X2) dans ebx
		mov eax,edx								;; placer Y1 (en fait Y2)
;		jmp Label16								;; aller Label16



;
; ici, on defini le premier point (enfin... celui qui est le plus  gauche)
;
Label16:	mov ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; placer x._Largeur_Ecran_X4_ dans ecx, pour obtenir un pas Y
		mul ecx									;; multiplier eax (Y1) par x._Largeur_Ecran_X4_
		mov edi,eax								;; placer Y1 * x._Largeur_Ecran_X4_ dans edi
; ici, on dfini si le dcalage Y est ngatif ou positif
		mov eax,_Ligne_Decalage_Y_					;; placer _Ligne_Decalage_Y_ dans eax
		test eax,eax								;; fixer les flags de eax
		jns Label17								;; si eax n'est pas sign, aller Label17
		neg eax									;; sinon, on inverse eax, pour obtenir un cart en hauteur positif
		neg ecx									;; inverser ecx (x._Largeur_Ecran_X4_), pour obtenir un pas Y ngatif
; ici, on sauvegarde le dcalage de ligne obtenu
Label17:	mov _Ligne_Decalage_Y_,ecx					;; sauvegarder ecx dans _Ligne_Decalage_Y_
; ici,
; eax = cart en hauteur
; ebx = cart en largeur
; esi = position X *4
; edi = position Y * (largeur cran *4)
;

; ici, on dtermine laquelle des 2 types de boucle on va utiliser
		cmp eax,ebx								;; comparer eax  ebx
		ja Label22								;; si eax est suprieur, aller Label22


;
; ici, on traite le cas o la largeur est la plus importante
;
		mov ecx,eax								;; sauvegarder l'cart en hauteur dans ecx
		mov eax,ebx								;; placer l'cart en largeur dans eax
		lea eax,[4*eax+esi]							;; multiplier l'cart en largeur par 4 et jouter esi (position X *4)
		mov _Ligne_Ecart_Maximal_,eax					;; sauvegarder le rsultat obtenu dans _Ligne_Ecart_Maximal_
		mov eax,ecx								;; replacer l'cart en hauteur dans eax
		mov ecx,ebx								;; copier ebx (l'cart en largeur) dans ecx
		test ecx,ecx								;; fixer les flags de ecx
		jz Label20								;; si ecx est gal  zro, aller Label20
		inc eax									;; incrmenter eax (pour compenser le dcalage occasionn par le 0)
;ALIGN 16
; dbut de la boucle
Label18:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ) test de prsence cran X
		jae Label21								;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;;	) test de prsence cran Y
		jae Label21								;;	)
; on place la couleur
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]					;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6								;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0					;; placer la couleur (le pixel)  l'adresse en edi+esi
		sub edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; et enlever l'adresse de dbut d'cran
; ici, on calcul les prochaines coordonnes
		sub ecx,eax								;; soustraire l'cart en hauteur  ecx
		jns Label19								;; si c'est positif, aller Label19
		add ecx,ebx								;; sinon, ajouter l'cart en largeur  ecx
		add edi,_Ligne_Decalage_Y_					;; ajouter _Ligne_Decalage_Y_  edi
Label19:	add esi,DWORD								;; augmenter esi d'1 DWORD
		cmp esi,_Ligne_Ecart_Maximal_					;; comparer esi  l'cart maximal en largeur
		jne Label18								;; tant que c'est diffrent, retourner Label18
; le dernier point
Label20:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ) test de prsence cran X
		jae Label21								;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;;	) test de prsence cran Y
		jae Label21								;;	)
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]					;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6								;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0					;; placer la couleur (le pixel)  l'adresse en edi+esi
; enfin, on restaure les registres...
Label21:	popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)

;
; ici, on traite le cas o la hauteur est la plus importante
;
Label22:	mov ecx,eax								;; sauvegarder l'cart en hauteur dans ecx
		imul _Ligne_Decalage_Y_						;; multiplier eax par _Ligne_Decalage_Y_ (sign car _Ligne_Decalage_Y_ peut tre ngatif)
		add eax,edi								;; ajouter edi  eax
		mov _Ligne_Ecart_Maximal_,eax					;; sauvegarder le rsultat obtenu dans _Ligne_Ecart_Maximal_
		mov eax,ecx								;; replacer l'cart en hauteur dans eax
		test ecx,ecx								;; fixer les flags de ecx
		jz Label25								;; si esi est gal  zro, aller Label25
		inc ebx									;; incrmenter ebx (pour compenser le dcalage occasionn par le 0)
;ALIGN 16
; dbut de la boucle
Label23:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ) test de prsence cran X
		jae Label26								;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;;	) test de prsence cran Y
		jae Label26								;;	)
; on place la couleur
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]					;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6								;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0					;; placer la couleur (le pixel)  l'adresse en edi+esi
		sub edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; et enlever l'adresse de dbut d'cran
; ici, on calcul les prochaines coordonnes
		sub ecx,ebx								;; soustraire l'cart en largeur  ecx
		jns Label24								;; si c'est positif, aller Label24
		add ecx,eax								;; sinon, ajouter l'cart en hauteur  ecx
		add esi,DWORD								;; ajouter DWORD  esi
Label24:	add edi,_Ligne_Decalage_Y_					;; augmenter edi de _Ligne_Decalage_Y_
		cmp edi,_Ligne_Ecart_Maximal_					;; comparer edi  l'cart maximal en hauteur
		jne Label23								;; tant que c'est diffrent, retourner Label23
; le dernier point
Label25:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ) test de prsence cran X
		jae Label26								;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;;	) test de prsence cran Y
		jae Label26								;;	)
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]					;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6								;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0					;; placer la couleur (le pixel)  l'adresse en edi+esi
; enfin, on restaure les registres...
Label26:	popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)


;
; ici, c'est l'algorythme le plus lent, la ligne entre (ou entre et sort) dans l'cran
;
Label27:	cmp eax,ecx								;; comparer la coordonne X1  X2
		jg Label28								;; si X1 est suprieur (sign, puisque l c'est possible)  X2, aller Label28
; ici on n'change pas la position des points
		mov esi,eax								;; sauvegarder la coordonne X1 dans esi
		shl esi,2									;; multiplier esi par 4, pour obtenir position X *4
		sub ecx,eax								;; enlever X1  X2
		sub edx,ebx								;; enlever Y1  Y2
		mov _Ligne_Decalage_Y_,edx					;; sauvegarder l'cart Y (Y2-Y1) dans _Ligne_Decalage_Y_
		mov eax,ebx								;; placer Y1 dans eax
		mov ebx,ecx								;; placer l'cart X (X2-X1) dans ebx
		jmp Label29								;; aller Label29
; ici on change la position des points (ce qui evitera les lignes "doubles" et le dcalage X sera automatiquement Positif)
Label28:	mov esi,ecx								;; sauvegarder la coordonne X1 (en fait X2) dans esi
		shl esi,2									;; multiplier esi par 4, pour obtenir position X *4
		sub eax,ecx								;; enlever X2  X1
		sub ebx,edx								;; enlever Y2  Y1
		mov _Ligne_Decalage_Y_,ebx					;; sauvegarder l'cart Y (Y1-Y2) dans _Ligne_Decalage_Y_
		mov ebx,eax								;; placer l'cart X (X1-X2) dans ebx
		mov eax,edx								;; placer Y1 (en fait Y2)
; ici, on defini le premier point (enfin... celui qui est le plus  gauche)
Label29:	mov ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; placer x._Largeur_Ecran_X4_ dans ecx, pour obtenir un pas Y
		mul ecx									;; multiplier eax (Y1) par x._Largeur_Ecran_X4_
		mov edi,eax								;; placer Y1 * x._Largeur_Ecran_X4_ dans edi
; ici, on dfini si le dcalage Y est ngatif ou positif
		mov eax,_Ligne_Decalage_Y_					;; placer _Ligne_Decalage_Y_ dans eax
		test eax,eax								;; fixer les flags de eax
		jns Label30								;; si eax n'est pas sign, aller Label30
		neg eax									;; sinon, on inverse eax, pour obtenir un cart en hauteur positif
		neg ecx									;; inverser ecx (x._Largeur_Ecran_X4_), pour obtenir un pas Y ngatif
; ici, on sauvegarde le dcalage de ligne obtenu
Label30:	mov _Ligne_Decalage_Y_,ecx					;; sauvegarder ecx dans _Ligne_Decalage_Y_
; ici,
; eax = cart en hauteur
; ebx = cart en largeur
; esi = position X *4
; edi = position Y * (largeur cran *4)
;

; ici, on dtermine laquelle des 2 types de boucle on va utiliser
		cmp eax,ebx								;; comparer eax  ebx
		ja Label40								;; si eax est suprieur, aller Label40
;
; ici, on traite le cas o la largeur est la plus importante
;
		mov ecx,eax								;; sauvegarder l'cart en hauteur dans ecx
		mov eax,ebx								;; placer l'cart en largeur dans eax
		lea eax,[4*eax+esi]							;; multiplier l'cart en largeur par 4 et jouter esi (position X *4)
		mov _Ligne_Ecart_Maximal_,eax					;; sauvegarder le rsultat obtenu dans _Ligne_Ecart_Maximal_
		mov eax,ecx								;; replacer l'cart en hauteur dans eax
		mov ecx,ebx								;; copier ebx (l'cart en largeur) dans ecx
		test ecx,ecx								;; fixer les flags de ecx
		jz Label34								;; si ecx est gal  zro, aller Label34
		inc eax									;; incrmenter eax (pour compenser le dcalage occasionn par le 0)
;ALIGN 16
; dbut de la boucle
Label31:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ) test de prsence cran X
		jae Label32								;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;;	) test de prsence cran Y
		jb Label37								;;	)
; ici, on calcul les prochaines coordonnes
Label32:	sub ecx,eax								;; soustraire l'cart en hauteur  ecx
		jns Label33								;; si c'est positif, aller Label33
		add ecx,ebx								;; sinon, ajouter l'cart en largeur  ecx
		add edi,_Ligne_Decalage_Y_					;; ajouter _Ligne_Decalage_Y_  edi
Label33:	add esi,DWORD								;; augmenter esi d'1 DWORD
		cmp esi,_Ligne_Ecart_Maximal_					;; comparer esi  l'cart maximal en largeur
		jne Label31								;; tant que c'est diffrent, retourner Label31
; le dernier point
Label34:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ) test de prsence cran X
		jae Label35								;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;;	) test de prsence cran Y
		jae Label35								;;	)
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]					;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6								;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0					;; placer la couleur (le pixel)  l'adresse en edi+esi
; enfin, on restaure les registres...
Label35:	popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)


; ici, le point le plus  gauche est dfini alors on trace ce qui reste de la ligne
;ALIGN 16
; dbut de la boucle
Label36:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ) test de prsence cran X
		jae Label39								;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;;	) test de prsence cran Y
		jae Label39								;;	)
Label37:	add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]					;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6								;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0					;; placer la couleur (le pixel)  l'adresse en edi+esi
		sub edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; et enlever l'adresse de dbut d'cran
; ici, on calcul les prochaines coordonnes
		sub ecx,eax								;; soustraire l'cart en hauteur  ecx
		jns Label38								;; si c'est positif, aller Label38
		add ecx,ebx								;; sinon, ajouter l'cart en largeur  ecx
		add edi,_Ligne_Decalage_Y_					;; ajouter _Ligne_Decalage_Y_  edi
Label38:	add esi,DWORD								;; augmenter esi d'1 DWORD
		cmp esi,_Ligne_Ecart_Maximal_					;; comparer esi  l'cart maximal en largeur
		jne Label36								;; tant que c'est diffrent, retourner Label36
; le dernier point
		cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ) test de prsence cran X
		jae Label39								;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;;	) test de prsence cran Y
		jae Label39								;;	)
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]					;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6								;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0					;; placer la couleur (le pixel)  l'adresse en edi+esi
; enfin, on restaure les registres...
Label39:	popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)


;
; ici, on traite le cas o la hauteur est la plus importante
;
Label40:	mov ecx,eax								;; sauvegarder l'cart en hauteur dans ecx
		imul _Ligne_Decalage_Y_						;; multiplier eax par _Ligne_Decalage_Y_ (sign car _Ligne_Decalage_Y_ peut tre ngatif)
		add eax,edi								;; ajouter edi  eax
		mov _Ligne_Ecart_Maximal_,eax					;; sauvegarder le rsultat obtenu dans _Ligne_Ecart_Maximal_
		mov eax,ecx								;; replacer l'cart en hauteur dans eax
		test ecx,ecx								;; fixer les flags de ecx
		jz Label44								;; si esi est gal  zro, aller Label44
		inc ebx									;; incrmenter ebx (pour compenser le dcalage occasionn par le 0)
;ALIGN 16
; dbut de la boucle
Label41:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ) test de prsence cran X
		jae Label42								;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;;	) test de prsence cran Y
		jb Label47								;;	)
; ici, on calcul les prochaines coordonnes
Label42:	sub ecx,ebx								;; soustraire l'cart en largeur  ecx
		jns Label43								;; si c'est positif, aller Label43
		add ecx,eax								;; sinon, ajouter l'cart en hauteur  ecx
		add esi,DWORD								;; ajouter DWORD  esi
Label43:	add edi,_Ligne_Decalage_Y_					;; augmenter edi de _Ligne_Decalage_Y_
		cmp edi,_Ligne_Ecart_Maximal_					;; comparer edi  l'cart maximal en hauteur
		jne Label41								;; tant que c'est diffrent, retourner Label41
; le dernier point
Label44:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ) test de prsence cran X
		jae Label45								;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;;	) test de prsence cran Y
		jae Label45								;;	)
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]					;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6								;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0					;; placer la couleur (le pixel)  l'adresse en edi+esi
; enfin, on restaure les registres...
Label45:	popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)


; ici, le point le plus  gauche est dfini alors on trace ce qui reste de la ligne
;ALIGN 16
; dbut de la boucle
Label46:	cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ) test de prsence cran X
		jae Label49								;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;;	) test de prsence cran Y
		jae Label49								;;	)
Label47:	add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]					;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6								;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0					;; placer la couleur (le pixel)  l'adresse en edi+esi
		sub edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; et enlever l'adresse de dbut d'cran
; ici, on calcul les prochaines coordonnes
		sub ecx,ebx								;; soustraire l'cart en largeur  ecx
		jns Label48								;; si c'est positif, aller Label48
		add ecx,eax								;; sinon, ajouter l'cart en hauteur  ecx
		add esi,DWORD								;; ajouter DWORD  esi
Label48:	add edi,_Ligne_Decalage_Y_					;; augmenter edi de _Ligne_Decalage_Y_
		cmp edi,_Ligne_Ecart_Maximal_					;; comparer edi  l'cart maximal en hauteur
		jne Label46								;; tant que c'est diffrent, retourner Label46
; le dernier point
		cmp esi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ) test de prsence cran X
		jae Label49								;; )
		cmp edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;;	) test de prsence cran Y
		jae Label49								;;	)
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; ajouter l'adresse de dbut d'cran  edi
		movd MM0,DWORD PTR [edi+esi]					;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6								;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+esi],MM0					;; placer la couleur (le pixel)  l'adresse en edi+esi
; enfin, on restaure les registres...
Label49:	popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_DessinerLigne_Alpha ENDP


ALIGN 16
;
; dessiner un point (un pixel) dans un cran
;
; Rceptionne :
; eax = position X (en pixels) du point dans l'cran (de 0  Largeur-1)
; ebx = position Y (en pixels) du point dans l'cran (de 0  Hauteur-1)
; esi = adresse (offset) de la structure _Bloc_Memoire_Ecran_ de l'cran
; edi = couleur du point  afficher (format A,R,V,B)
;
; Retourne :
; rien, (attention, les registres MM0  MM5 sont modifis)
;
; Syntaxe : Mmx_DessinerPoint_Alpha
;
Mmx_DessinerPoint_Alpha PROC

; ici, on teste si les coordonnes du point se situent bien dans l'cran, sinon on sort...
		cmp eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_	;; comparer X  x._Largeur_Ecran_
		jae Label1								;; si X est suprieure ou gale  la largeur cran, aller Label1
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [esi])._Hauteur_Ecran_	;; comparer Y  x._Hauteur_Ecran_
		jae Label1								;; si Y est suprieure ou gale  la hauteur cran, aller Label1
; l, le point est bien situ dans l'cran
		push eax									;; empiler eax
		push ecx									;; empiler ecx
		push edx									;; empiler edx ( cause de la multiplication)
		mov ecx,edi								;; copier la couleur dans ecx
		and ecx,0FF000000h							;; conserver l'alpha de la couleur dans ecx
		movd MM2,ecx								;; MM2 = A,0,0,0
; on dfini l'adresse
		mov ecx,eax								;; on copie eax dans ecx
		mov eax,(_Bloc_Memoire_Ecran_ PTR [esi])._Largeur_Ecran_X4_	;; on place x._Largeur_Ecran_X4_ dans eax
		mul ebx									;; on multiplie eax par le nombre de lignes
		shl ecx,2									;; on multiplie eax par 4 (pour transormer les pixels en dwords)
		add ecx,eax								;; on ajoute eax  ecx
		add ecx,(_Bloc_Memoire_Ecran_ PTR [esi])._Pointeur_	;; on ajoute ensuite le pointeur de la zone du bloc cran
; et on affiche le point
		movd MM0,DWORD PTR [ecx]						;; MM0 = A,R,V,B (lire la couleur de fond)
		movd MM1,edi								;; MM1 = A,R,V,B (lire la couleur  appliquer)
		movq MM3,MM2								;; MM3 = A,0,0,0
		psrlq MM3,8								;; MM3 = 0,A,0,0
		psrlq MM2,24								;; MM2 = 0,0,0,A
		punpckldq MM2,MM2							;; MM2 = 0,0,0,A , 0,0,0,A
		por MM2,MM3								;; MM2 = 0,0,0,A , 0,A,0,A
		pxor MM7,MM7								;; MM7 = 0,0,0,0 , 0,0,0,0
		movq MM3,MM2								;; MM3 = 0,0,0,A , 0,A,0,A
		pxor MM3,QWORD PTR _Ligne_Mmx_Masque_ARVB_unpck_	;; MM3 = 0,M,0,M , 0,M,0,M
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [ecx],MM0						;; placer la couleur (le pixel)  l'adresse en ecx
		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop eax									;; dsempiler eax
Label1:
	ret											;; retourner (sortir de la procdure)
Mmx_DessinerPoint_Alpha ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routine de conversion valeur -> chaine de caractre dcimale
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.CODE
ALIGN 16
;
; convertir un dword en texte au format dcimale (routine la plus stable pour le job)
; note : cette routine n'est pas de moi, je sais plus o je l'ai rcupre, mais si je me souviens bien,
; c'est une adaption d'un algo cr par pdixon/michealw (ou quelque chose comme c... au dbut, j'aimait pas
; trop le bidouillage qui faisait passer le +1 en eax dans le multiplicateur, mais aprs tout, si ca fait le job,
; pourquoi pas...)
;
; Rceptionne :
; eax = la valeur
; esi = adresse de la chaine de caractres  crer
;
; Retourne :
; rien
;
; syntaxe : ConvertirValeurEnChaineDecimale
;
ConvertirValeurEnChaineDecimale PROC
		push eax									;; empiler eax
		push ebx									;; empiler ebx
		push ecx									;; empiler ecx
		push edx									;; empiler edx
		push esi									;; empiler esi

		mov ecx,eax								;; copier eax dans ecx
; on va diviser eax par 100000 de manire optimise
		mov edx,2814749768							;; placer 2814749768 (remplacement de 2814749767 et eax+1) dans edx
		mul edx									;; multiplier eax par 2814749768
		shr edx,16								;; dcaler edx de 16 bits  droite
		mov eax,100000								;; placer 100000 dans eax
		mov ebx,edx								;; copier edx dans ebx
		mul edx									;; multiplier edx par 100000
		sub ecx,eax								;; soustraire le rsultat en eax  ecx
		test ebx,ebx								;; fixer les flags de ebx
		mov edx,ebx								;; replacer ebx dans edx
		mov ebx,10								;; placer 10 (notre multiplicateur dcimale) dans ebx
		jz Label01								;; si c'est gal  0, aller Label01
; sinon, on traite la partie suprieure du nombre
		mov eax,429497								;; on remplace eax par 429497
		mul edx									;; multiplier edx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label02								;; s'il existe un dpassement, aller Label02
		mul ebx									;; multiplier eax par 10
		jc Label03								;; s'il existe un dpassement, aller Label03
		mul ebx									;; multiplier eax par 10
		jc Label04								;; s'il existe un dpassement, aller Label04
		mul ebx									;; multiplier eax par 10
		jc Label05								;; s'il existe un dpassement, aller Label05
		mul ebx									;; multiplier eax par 10
		jc Label06								;; s'il existe un dpassement, aller Label06
; ici, on traite la partie infrieure du nombre
Label01:	mov eax,429497								;; on remplace eax par 429497
		mul ecx									;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label07								;; s'il existe un dpassement, aller Label07
		mul ebx									;; multiplier eax par 10
		jc Label08								;; s'il existe un dpassement, aller Label08
		mul ebx									;; multiplier eax par 10
		jc Label09								;; s'il existe un dpassement, aller Label09
		mul ebx									;; multiplier eax par 10
		jc Label10								;; s'il existe un dpassement, aller Label10
		mul ebx									;; multiplier eax par 10
		jmp Label11								;; aller Label11
; maintenant on va calculer et copier chaque octets/caractres
Label02:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label03:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label04:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label05:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label06:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi

		mov eax,429497								;; on remplace eax par 429497
		mul ecx									;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)

		inc esi									;; ajouter 1 octet  l'adresse en esi
Label07:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label08:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label09:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label10:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mul ebx									;; multiplier eax par 10
		inc esi									;; ajouter 1 octet  l'adresse en esi
Label11:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl						;; placer l'octet en dl  l'adresse en esi
		mov BYTE PTR [esi+1],0						;; placer le 0 final  l'adresse en esi+1
		xor eax,eax								;; effacer eax

		pop esi									;; dsempiler esi
		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop ebx									;; dsempiler ebx
		pop eax									;; dsempiler eax
	ret											;; retourner (sortir de la procdure)
ConvertirValeurEnChaineDecimale ENDP


; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * routines de traitement de chaines de caractres graphiques
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.DATA
ALIGN 16
_Chaine_Position_Ecran_X_		DWORD ?,?,?,?			;; (align 16)
_Chaine_Position_Ecran_Y_		DWORD ?,?,?,?			;; (align 16)
_Chaine_Boucle_Largeur_			DWORD ?,?,?,?			;; (align 16)
_Chaine_Adresse_Police_			DWORD ?,?,?,?			;; (align 16)
_Chaine_Couleur_Police_			DWORD 000FFFFFFh,?,?,?	;; (align 16) blanc par dfaut
_Chaine_Couleur_Fond_			DWORD 000000000h,?,?,?	;; (align 16) noir par dfaut
_Chaine_Adresse_Caractere_		DWORD ?,?,?,?			;; (align 16)
_Chaine_Largeur_Caractere_X4_		DWORD ?,?,?,?			;; (align 16)
_Chaine_Passage_Caractere_Suivant_	DWORD ?,?,?,?			;; (align 16)
_Chaine_Hauteur_Police_			DWORD ?,?,?,?			;; (align 16)
_Chaine_Mmx_Masque_Alpha_movd_	DWORD 0FF000000h,0FF000000h,0FF000000h,0FF000000h
_Chaine_Mmx_Masque_ARVB_unpck_	DWORD 000FF00FFh,000FF00FFh,000FF00FFh,000FF00FFh
; note : ici, toutes les variables sont alignes sur 16 octets pour une question de rapidit


.CODE
ALIGN 16
;
; Afficher une chane de caractres (largeur maximale des caractres de la police = 32 pixels, (ce qui est suffisant
; dans la plupart des cas...)) sans s'occuper du fond
; (cette version considre que tous les alphas de la couleur de la police ont la mme valeur, ce qui est
; gnralement le cas...)
;
; Rceptionne :
; eax = position X (largeur en pixels) de dpart
; ebx = position Y (hauteur en pixels) de dpart
; edx = adresse de la police de caratres  utiliser
; esi = adresse de la chaine  afficher
; edi = adresse (offset) de la structure cran
;
; Retourne :
; rien, mais la chaine est affiche  l'cran (attention, tous les registre MMx sont modifis)
;
; Syntaxe : Mmx_AfficherChaineSansFond_Alpha_Turbo
;
Mmx_AfficherChaineSansFond_Alpha_Turbo PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

; on initialise les variables que l'on va utiliser
		mov ebp,edi								;; sauvegarder l'adresse de la structure _Bloc_Memoire_Ecran_ dans ebp
		mov _Chaine_Adresse_Police_,edx				;; sauvegarder l'adresse de la police utilise
		mov _Chaine_Adresse_Caractere_,esi				;; sauvegarder l'adresse du caractre  afficher
		mov esi,DWORD PTR [edx]						;; placer la hauteur de la police dans esi
		mov _Chaine_Hauteur_Police_,esi				;; placer la hauteur de la police dans _Chaine_Hauteur_Police_
; calculer la position X
		shl eax,2									;; multiplier la position X par 4
		mov _Chaine_Position_Ecran_X_,eax				;; sauvegarder la position dans la variable _Chaine_Position_Ecran_X_
; calculer la zone cran
		mov ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; placer la largeur d'une ligne cran x4 dans ecx
		mov edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; placer l'adresse de dpart de l'cran dans edi
; calculer la position Y
		mov eax,ecx								;; placer la largeur d'une ligne cran x4 dans eax
		imul ebx									;; multiplier par la hauteur
; on dfini la position Y dans l'cran
		add edi,eax								;; ajouter la position Y  l'adresse de dpart
; calculer le dcalage cran pour passer au caractre suivant
		mov eax,ecx								;; placer la largeur d'une ligne cran x4 dans eax
		mul _Chaine_Hauteur_Police_					;; multiplier par la hauteur de la police
		mov _Chaine_Passage_Caractere_Suivant_,eax		;; sauvegarder le dcalage
		mov ebx,_Chaine_Position_Ecran_X_				;; placer la position  crire dans ebx
		movd MM6,_Chaine_Couleur_Police_				;; MM6 = A,R,V,B
		movd MM2,_Chaine_Couleur_Police_				;; MM2 = A,R,V,B
		pand MM2,QWORD PTR _Chaine_Mmx_Masque_Alpha_movd_	;; MM2 = A,0,0,0
		movq MM3,MM2								;; MM3 = A,0,0,0
		psrlq MM3,8								;; MM3 = 0,A,0,0
		psrlq MM2,24								;; MM2 = 0,0,0,A
		punpckldq MM2,MM2							;; MM2 = 0,0,0,A , 0,0,0,A
		por MM2,MM3								;; MM2 = 0,0,0,A , 0,A,0,A
		movq MM3,MM2								;; MM3 = 0,0,0,A , 0,A,0,A
		pxor MM3,QWORD PTR _Chaine_Mmx_Masque_ARVB_unpck_	;; MM3 = 0,M,0,M , 0,M,0,M
		pxor MM7,MM7								;; MM7 = 0,0,0,0 , 0,0,0,0
;ALIGN 16
; on traite la chane de caractres, pour commencer on teste si c'est la fin de chane
Label01:	mov edx,_Chaine_Adresse_Caractere_				;; placer l'adresse du caractre  afficher dans edi
		movzx eax,BYTE PTR [edx]						;; placer le caractre  afficher dans eax
		test eax,eax								;; fixer les flags de eax
		jz Label14								;; si eax est gal  zro (fin de chane), aller Label14 (la sortie)
; sinon, on teste la validit du caractre
		cmp eax,32								;; comparer le caractre  32 (caractre minimal  afficher)
		jb Label07								;; si c'est infrieur  32, aller Label07
		mov esi,_Chaine_Adresse_Police_				;; placer l'adresse de la police dans esi
		mov ecx,DWORD PTR [esi]						;; et lire la hauteur des caractres
		shl ecx,2									;; multiplier ecx par 4 (puisque, ici, on lit des dwords)
		cmp eax,DWORD PTR [esi+4]					;; comparer notre caractre au caractre maximal trait par la police
		jbe Label02								;; si c'est infrieur ou gal au caractre maximal, aller Label02
		mov eax,127								;; sinon, placer 127 (le caractre maxi d'une police restreinte) dans eax
Label02:	sub eax,32								;; enlever les 32 caractres "non affichables"  eax
; on cherche l'emplacement des donnes du caractre  afficher
		add ecx,4									;; ajouter le dword correspondant  la largeur du caractre
		mul ecx									;; multiplier le caractre en eax par la "hauteur" des caractres
		add esi,eax								;; ajouter le rsultat obtenu  l'adresse de dpart de la police
; ici, esi+8 = largeur du caractre, et esi+12 = adresse des donnes du caractre
		mov eax,DWORD PTR [esi+8]					;; placer la largeur du caractre dans eax
		shl eax,2									;; multiplier cette largeur par 4 (puisqu'on lit des dwords)
		mov _Chaine_Largeur_Caractere_X4_,eax			;; sauvegarder la largeur du caractre *4 en cours de traitement
; on dfini la boucle pour la hauteur
		mov eax,_Chaine_Hauteur_Police_				;; lire la hauteur des caractres
		shl eax,2									;; multiplier cette hauteur par 4, (puisqu'on lit des dwords)
		add esi,eax								;; ajouter eax  esi
		neg eax									;; inverser eax (qui devient notre compteur de boucle pour la hauteur)

; on teste si le caractre est pleinement dans l'cran
		mov edx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;; ) test de prsence cran Y
		mov ecx,edi								;; )
		sub ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; )
		cmp ecx,edx								;; )
		jae Label08								;; )
		add ecx,_Chaine_Passage_Caractere_Suivant_		;; )
		cmp ecx,edx								;; )
		jae Label08								;; )
		mov edx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;;	) test de presence cran X
		mov ecx,ebx								;;	)
		cmp ecx,edx								;;	)
		jae Label08								;;	)
		add ecx,_Chaine_Largeur_Caractere_X4_			;;	)
		cmp ecx,edx								;;	)
		jae Label08								;;	)

;ALIGN 16
; ici, le caractre est entirement dans l'cran, boucle pour la hauteur, on dfini la boucle pour la largeur
Label03:	mov ecx,DWORD PTR [esi+eax+12]				;; placer le dword  l'adresse en esi+eax+12 dans ecx (+12,  pour le dword de la hauteur, le dword du caractre maxi et le dword de la largeur du caractre)
		mov edx,_Chaine_Largeur_Caractere_X4_			;; placer la largeur du caractre *4 dans edx (qui sera notre compteur de boucle)
;ALIGN 16
; boucle pour la largeur, placer la couleur approprie en fonction du bit positionn
Label04:	shl ecx,1									;; sinon, tester les bits "de 31  31-largeur"
		jnc Label05								;; si le flag carry n'est pas positionn, aller Label05
; ici, application de la transparence alpha sur le pixel
		movd MM0,DWORD PTR [edi+ebx]					;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6								;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+ebx],MM0					;; placer la couleur (le pixel)  l'adresse en edi+esi
Label05:	add ebx,4									;; pour aller traiter le pixel suivant de la ligne
; fin boucle largeur
		sub edx,4									;; enlever 1 pixel  notre compteur de boucle
		jnz Label04								;; tant que c'est diffrent de 0, aller Label04
; sinon, on passe  la ligne suivante
		sub ebx,_Chaine_Largeur_Caractere_X4_			;; soustraire la largeur traite, pour paser  la ligne suivante
		add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ajouter la largeur d'une ligne pour passer  la ligne de pixels suivante
; fin boucle hauteur
		add eax,4									;; incrmenter d'1 dword le compteur de boucle pour la hauteur
		jnz Label03								;; tant que eax n'est pas gal  zro, aller Label03
; sinon, on passe au caractre  afficher suivant
		sub edi,_Chaine_Passage_Caractere_Suivant_		;; soustraire le dcalage  edi
		add ebx,_Chaine_Largeur_Caractere_X4_			;; ajouter la largeur du caractre trait  ebx
; fin boucle caractres
Label07:	inc _Chaine_Adresse_Caractere_				;; augmenter l'adresse du caractre  afficher d'1 caractre
		jmp Label01								;; aller Label01

;ALIGN 16
; ici, le caractre n'est pas entirement dans l'cran, boucle pour la hauteur
Label08:	mov ecx,edi								;; ) test de prsence cran Y
		sub ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Pointeur_	;; )
		cmp ecx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Taille_Du_Bloc_	;; )
		jae Label13								;; )
; sinon, on dfini la boucle pour la largeur
		mov ecx,DWORD PTR [esi+eax+12]				;; sinon, placer le dword  l'adresse en esi+eax+12 dans ecx (+12,  pour le dword de la hauteur, le dword du caractre maxi et le dword de la largeur du caractre)
		mov edx,_Chaine_Largeur_Caractere_X4_			;; placer la largeur du caractre *4 dans edx (qui sera notre compteur de boucle)
;ALIGN 16
; boucle pour la largeur, placer la couleur approprie en fonction du bit positionn
Label09:	shl ecx,1									;; sinon, tester les bits "de 31  31-largeur"
		jnc Label10								;; si le flag carry n'est pas positionn, aller Label10
		cmp ebx,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ) test de presence cran X
		jae Label10								;; )
; ici, application de la transparence alpha sur le pixel
		movd MM0,DWORD PTR [edi+ebx]					;; MM0 = A,R,V,B (lire la couleur de fond)
		movq MM1,MM6								;; MM1 = A,R,V,B (lire la couleur  appliquer)
		punpcklbw MM0,MM7							;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7							;; MM1 = 0,A,0,R , 0,V,0,B
		pmullw MM1,MM2								;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM3								;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM1								;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8								;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7							;; MM0 = A,R,V,B , 0,0,0,0
		movd DWORD PTR [edi+ebx],MM0					;; placer la couleur (le pixel)  l'adresse en edi+esi
Label10:	add ebx,4									;; pour aller traiter le pixel suivant de la ligne
; fin boucle largeur
		sub edx,4									;; enlever 1 pixel  notre compteur de boucle
		jnz Label09								;; tant que c'est diffrent de 0, aller Label09
; sinon, on passe  la ligne suivante
		sub ebx,_Chaine_Largeur_Caractere_X4_			;; soustraire la largeur traite, pour paser  la ligne suivante
Label13:	add edi,(_Bloc_Memoire_Ecran_ PTR [ebp])._Largeur_Ecran_X4_	;; ajouter la largeur d'une ligne pour passer  la ligne de pixels suivante
; fin boucle hauteur
		add eax,4									;; incrmenter d'1 dword le compteur de boucle pour la hauteur
		jnz Label08								;; tant que eax n'est pas gal  zro, aller Label08
; sinon, on passe au caractre  afficher suivant
		sub edi,_Chaine_Passage_Caractere_Suivant_		;; soustraire le dcalage  edi
		add ebx,_Chaine_Largeur_Caractere_X4_			;; ajouter la largeur du caractre trait  ebx
		inc _Chaine_Adresse_Caractere_				;; augmenter l'adresse du caractre  afficher d'1 caractre
		jmp Label01								;; aller Label01
Label14:
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
Mmx_AfficherChaineSansFond_Alpha_Turbo ENDP


ALIGN 16
;
; dfinir les couleurs (caractres + fond) d'une chane de caractres
; note : ca peut paraitre stupide de crer une procdure avec seulement 2 instructions, mais ca permet d'eviter
; de rpeter cette opration systmatiquement dans AfficherChaine (gain de vitesse), et c'est aussi quelque chose
; qui peut tre appel un nombre de fois considrable (donc, une macro prendrai beucoup plus d'espace mmoire)
;
; Rceptionne :
; eax = couleur de la police de caractres
; ebx = couleur de fond de la police de caractres
;
; Retourne :
; rien, mais les variables _Chaine_Couleur_Police_ et _Chaine_Couleur_Fond_ qui servent pour AfficherChaine est dfinie
;
; Syntaxe : DefinirCouleursChaine
;
DefinirCouleursChaine PROC
		mov _Chaine_Couleur_Police_,eax				;; sauvegarder la couleur de la police
		mov _Chaine_Couleur_Fond_,ebx					;; sauvegarder la couleur de fond de la police
	ret											;; retourner (sortir de la procdure)
DefinirCouleursChaine ENDP
