;
; Test points/lignes
;

.686P											; minimum = pentium pro (ou 2) avec le mode privilegi
.MMX												; pour activer les instructions mmx
.XMM												; pour activer les instructions sse,sse2
.MODEL flat, stdcall
.STACK 4096

OPTION SCOPED										; les labels locaux sont autoriss, et les labels globaux  l'intrieur des procdures doivent tre dfinis avec 2 fois 2 points (LABEL::)
OPTION LJMP										; lors de la compilation, le compileur prviendra si un jmp pourra tre court (SHORT)
OPTION CASEMAP:NONE									; optionel: rends les identifiants sensibles  la casse de caractres


;
; fichiers INCLUDE
;
INCLUDE \Masm32\INCLUDE\windows.inc
INCLUDE \Masm32\INCLUDE\kernel32.inc
INCLUDE \MAsm32\INCLUDE\masm32.inc
INCLUDE \Masm32\INCLUDE\user32.inc
INCLUDE \Masm32\INCLUDE\gdi32.inc
INCLUDE \Masm32\INCLUDE\Comctl32.inc
INCLUDE \Masm32\INCLUDE\comdlg32.inc
;INCLUDE \Masm32\INCLUDE\ole32.inc
;INCLUDE \Masm32\INCLUDE\oleaut32.inc
;INCLUDE \Masm32\INCLUDE\winmm.inc
;INCLUDE \Masm32\INCLUDE\shell32.inc
;INCLUDE \Masm32\INCLUDE\ .inc


;
; Fichiers LIBRAIRIES
;
INCLUDELIB \Masm32\LIB\kernel32.lib
INCLUDELIB \Masm32\LIB\user32.lib
INCLUDELIB \MAsm32\LIB\masm32.lib
INCLUDELIB \Masm32\LIB\gdi32.lib
INCLUDELIB \Masm32\LIB\Comctl32.lib
INCLUDELIB \Masm32\LIB\comdlg32.lib
;INCLUDELIB \Masm32\LIB\ole32.lib
;INCLUDELIB \Masm32\LIB\oleaut32.lib
;INCLUDELIB \Masm32\LIB\winmm.lib
;INCLUDELIB \Masm32\LIB\shell32.lib
;INCLUDELIB \Masm32\LIB\ .lib


;
; Prototypes
;

ProgrammePrincipal				PROTO
GestionnaireMessages			PROTO :DWORD,:DWORD,:DWORD,:DWORD
GestionnaireMessagesBoiteDialogue	PROTO :DWORD,:DWORD,:DWORD,:DWORD


.CONST
;
; Constantes
;


Taille_Pile_Processus_Principal	EQU 16

Largeur_Ecran_Travail			EQU 800	;1024	;512
Hauteur_Ecran_Travail			EQU 600	;;768	;384
Largeur_Ecran_Final				EQU 800	;1024	;512				;; ) gros ralentissement lorsque la taille diffre du bloc de travail, a cause du retaillage...
Hauteur_Ecran_Final				EQU 600	;768	;384				;; )
Largeur_Ecran_Travail_Moitiee		EQU Largeur_Ecran_Travail/2
Hauteur_Ecran_Travail_Moitiee		EQU Hauteur_Ecran_Travail/2

Vitesse_Deplacement_Minimale		EQU 2		;; 2 (sur 4096)
Vitesse_Acceleration			EQU 16
Vitesse_Deceleration			EQU 16
Vitesse_Deplacement_Maximale		EQU 128+Vitesse_Deplacement_Minimale

Angle_Z_Minimal				EQU -128
Angle_Z_Maximal				EQU 128

Nombre_Etoiles					EQU 1024
Taille_Structure_Etoile			EQU 32
Couleur_Jaune					EQU 0FFDFDF3Fh			;; 223,223,063


.DATA
;
; Definition des STRUCTURES
;

; structure pour la cration/la suppression d'une l'instance mmoire
_Informations_Memoire_	STRUCT						;; pour un total de 16 octets
	_Instance_			DWORD ?					;; pointeur de l'instance
	_Taille_Initiale_		DWORD ?					;; taille initiale (dfinie par HeapCreate)
	_Taille_Maximale_		DWORD ?					;; taille maximale (dfinie par HeapCreate)
	_Inutilise_01_			DWORD ?					;; inutilis, pour le moment... (mais ncessaire pour que la structure aligne ce qui suivra)
_Informations_Memoire_	ENDS

; structure pour l'allocation/la libration d'un bloc mmoire
_Bloc_Memoire_	STRUCT								;; pour un total de 16 octets
	_Taille_Du_Bloc_		DWORD ?					;; taille du bloc (moins les 16 octets ncessaires  l'alignement)
	_Pointeur_A_Liberer_	DWORD ?					;; adresse qui sert pour librer/supprimer le bloc
	_Pointeur_			DWORD ?					;; pointeur de la zone utilisable (align sur 16 octets)
	_Inutilise_01_			DWORD ?					;; inutilis, pour le moment... (mais ncessaire pour que la structure aligne ce qui suivra)
_Bloc_Memoire_	ENDS

; structure pour l'allocation/la libration d'un bloc mmoire spcifique aux crans
_Bloc_Memoire_Ecran_	STRUCT						;; pour un total de 32 octets
	_Taille_Du_Bloc_		DWORD ?					;; (align 16) taille du bloc (moins les 16 octets ncessaires  l'alignement)
	_Pointeur_A_Liberer_	DWORD ?					;; adresse qui sert pour librer/supprimer le bloc
	_Pointeur_			DWORD ?					;; pointeur de la zone utilisable (adresse aligne sur 16 octets)
	_Largeur_Ecran_		DWORD ?					;; largeur de l'cran (en pixels)
	_Largeur_Ecran_X4_		DWORD ?					;; (align 16) largeur de l'cran relle multiplie par 4 (*DWORD) (ajout, parceque souvent utilis, evite donc des shl,2)
	_Hauteur_Ecran_		DWORD ?					;; hauteur de l'cran (en pixels)
	_Pointeur_Zbuffer_		DWORD ?					;; pointeur de la zone Zbuffer (quand c'est un cran double, sinon, c'est une copie du pointeur)
	_Pointeur_LimitesFace_	DWORD ?					;; pointeur de la zone limites face (zro quand ce n'est pas un cran double)
_Bloc_Memoire_Ecran_	ENDS

; cette structure n'est prsente qu'a titre d'information (puisque j'utilise registre+offset)
_Structure_Etoile_	STRUCT							;; pour un total de 32 octets
	_X_3D_			DWORD ?						;; offset 0, position 3D x
	_Y_3D_			DWORD ?						;; offset 4, position 3D y
	_Z_3D_			DWORD ?						;; offset 8, position 3D z
	_inutilise_		DWORD ?						;; offset 12, inutilis pour le moment...
	_X_2D_			DWORD ?						;; offset 16, position 2D x
	_Y_2D_			DWORD ?						;; offset 20, position 2D y
	_Ancien_X_2D_		DWORD ?						;; offset 24, ancienne position 2D x (pour un effet de mouvement/traine)
	_Ancien_Y_2D_		DWORD ?						;; offset 28, ancienne position 2D y (pour un effet de mouvement/traine)
_Structure_Etoile_	ENDS


.DATA
;
; Variable dfinies
;
INCLUDE TableSinusCosinus12Bits.inc
INCLUDE Police_Xx16.inc

ALIGN 16
; quelques compteurs
Compteur_Boucle_Etoies			DWORD 0
Compteur_Des_images				DWORD 0


; variables diverses
Instance_Application			DWORD ?
Instance_Boite_Dialogue			DWORD ?
Pointeur_Ligne_Commande			DWORD 0
Pointeur_Fenetre				DWORD ?
Pointeur_DC_Ecran				HDC ?
Pointeur_Processus_Principal		DWORD ?

Vitesse_Deplacement				DWORD Vitesse_Deplacement_Minimale			; la vitesse par dfaut de dplacement dans notre starfield


;
; variables 3D
;
Position_X		DWORD ?							;; ) positions temporaires
Position_Y		DWORD ?							;; )
Position_Z		DWORD ?							;; )
Deplacement_X		DWORD ?							;;	) dplacements
Deplacement_Y		DWORD ?							;;	)
Deplacement_Z		DWORD ?							;;	)
Angle_X			DWORD ?							;; ) angles de rotation
Angle_Y			DWORD ?							;; )
Angle_Z			DWORD ?							;; ) par dfaut, pas de rotation
Focale_X			DWORD ?							;;	) point de vue
Focale_Y			DWORD ?							;;	)
Focale_Z			DWORD ?							;;	)
Sinus_X			DWORD ?							;; ) Sinus temporaires
Sinus_Y			DWORD ?							;; )
Sinus_Z			DWORD ?							;; )
Cosinus_X			DWORD ?							;;	) Cosinus temporaires
Cosinus_Y			DWORD ?							;;	)
Cosinus_Z			DWORD ?							;;	)


;
; variables 2D (lignes, points, ...)
;
Position_Ecran_X		DWORD ?
Position_Ecran_Y		DWORD ?
Mouvement_Souris_X		DWORD 0
Mouvement_Souris_Y		DWORD 0
Couleur_Etoile			DWORD 0


;
; quelques tmoins
;
Temoin_Afficher_Trainee			BYTE 1				;; ici, on place TRUE
Temoin_Des_Statistiques			BYTE 1
Temoin_Effet_Fondu				BYTE 1
Temoin_Type_Fondu				BYTE 0
Temoin_Poursuite_Processus		BYTE 1				;; 0=termin, 1=actif
Temoin_Redimensionnement			BYTE ?				;; 0=pas de redimensionnement, 1=redimensionnement *2, 2=redimensionnement autre que *2
; variables permettant de connaitre  tout moment le statut des boutons de la souris
Temoin_Bouton_Souris_Gauche		BYTE ?
Temoin_Bouton_Souris_Milieu		BYTE ?
Temoin_Bouton_Souris_Droit		BYTE ?


; chaines de caractres
Chaine_Titre_Fenetre			BYTE "Starfield",0
Chaine_Type_Fenetre				BYTE "Type Personnalis",0
Chaine_Boite_Dialogue_Insuffisant	BYTE "DialogueInsuffisant",0
Chaine_Boite_Dialogue_Quitter		BYTE "DialogueQuitter",0
Chaine_Images_Seconde			BYTE "Nombre d'images par secondes : "
Chaine_Nombre_Images_Seconde		BYTE 12 DUP(0h)


ALIGN 16
; definition des variables structures
Instance_Memoire				_Informations_Memoire_ <?>
Tampon_Ecran_Travail			_Bloc_Memoire_Ecran_ <?>
Tampon_Ecran_Final				_Bloc_Memoire_Ecran_ <?>
Tampon_Table_Redimensionnement	_Bloc_Memoire_ <?>
Tampon_Etoiles					_Bloc_Memoire_ <?>
Informations_Fenetre			WNDCLASSEX <?>			;; 12 Dwords

; structure BITMAPINFO (elle est dcompose, parcequ'il semble qu'il y ai des difficults pour assembler du code
; lorsque la premire valeur d'une structure est une autre structure...
Informations_Bitmap				BITMAPINFOHEADER <?>	;; ) bmiHeader (BITMAPINFOHEADER) (3 Dwords + 2 Words + 6 Dwords) + bmiColors (RGBQUAD) (4 octets)
Informations_Bitmap_Suite_1		RGBQUAD <?>			;; )

Informations_Messages_OS			MSG <?>				;; 5 Dwords + 2 Words


.CODE
;
; les Macros
;


.CODE
;
; les procdures gnriques utilises
;
INCLUDE SomeProcs.asm


.CODE
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * ici, les procdures spcifiquemet cres pour le starfield
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *


ALIGN 16
;
; gnrateur des pixels qui vont donner l'effet starfield
;
DessinerEtoiles PROC
		pushad									;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

;
; dfinition de la vitesse de dplacement en fonction du statut de la souris
;
		cmp Temoin_Bouton_Souris_Droit,1				;; le bouton souris droit est press ?
		jne EviterIncrementerVitesseDeplacement			;; si ce n'est pas le cas, aller EviterIncrementerVitesseDeplacement
		cmp Vitesse_Deplacement,Vitesse_Deplacement_Maximale	;; comparer la vitesse de dplacement  Vitesse_Deplacement_Maximale
		je EviterIncrementerVitesseDeplacement			;; si c'est gal, aller EviterIncrementerVitesseDeplacement
		add Vitesse_Deplacement,Vitesse_Acceleration		;; sinon, augmenter la vitesse de dplacement
		jmp EviterDecrementerVitesseDeplacement			;; et aller EviterDecrementerVitesseDeplacement
EviterIncrementerVitesseDeplacement:
		cmp Vitesse_Deplacement,Vitesse_Deplacement_Minimale	;; comparer la vitesse de dplacement  Vitesse_Deplacement_Minimale
		je EviterDecrementerVitesseDeplacement			;; si c'est gal, aller EviterDecrementerVitesseDeplacement
		sub Vitesse_Deplacement,Vitesse_Deceleration		;; sinon, diminuer la vitesse de dplacement
EviterDecrementerVitesseDeplacement:


;
; obtenir le sinus et le Cosinus de x,y,z
;

;; obtenir le sinus et le cosinus de x
;		mov ebx,Angle_X							;; placer l'angle (utilis comme pointeur de 0  FFF) dans ebx
;		and ebx,0FFFh								;; filtrer ebx pour ne conserver que les valeurs de 0  4095
;		mov eax,[TableSinus+4*ebx]					;; obtenir le sinus de la table dans eax
;		mov Sinus_X,eax							;; sauvegarder le rsultat obtenu dans Sinus_X
;		mov eax,[TableCosinus+4*ebx]					;; obtenir le cosinus de la table dans eax
;		mov Cosinus_X,eax							;; sauvegarder le rsultat obtenu dans Cosinus_X
;; obtenir le sinus et le cosinus de y
;		mov ebx,Angle_Y							;; placer l'angle (utilis comme pointeur de 0  FFF) dans ebx
;		and ebx,0FFFh								;; filtrer ebx pour ne conserver que les valeurs de 0  4095
;		mov eax,[TableSinus+4*ebx]					;; obtenir le sinus de la table dans eax
;		mov Sinus_Y,eax							;; sauvegarder le rsultat obtenu dans Sinus_Y
;		mov eax,[TableCosinus+4*ebx]					;; obtenir le cosinus de la table dans eax
;		mov Cosinus_Y,eax							;; sauvegarder le rsultat obtenu dans Cosinus_Y

; obtenir le sinus et le cosinus de z
		mov ebx,Angle_Z							;; placer l'angle (utilis comme pointeur de 0  FFF) dans ebx
		and ebx,0FFFh								;; filtrer ebx pour ne conserver que les valeurs de 0  4095
		mov eax,[TableSinus+4*ebx]					;; obtenir le sinus de la table dans eax
		mov Sinus_Z,eax							;; sauvegarder le rsultat obtenu dans Sinus_Z
		mov eax,[TableCosinus+4*ebx]					;; obtenir le cosinus de la table dans eax
		mov Cosinus_Z,eax							;; sauvegarder le rsultat obtenu dans Cosinus_Z


;
; la boucle pour les toiles commence ici...
;
		mov eax,Nombre_Etoiles						;; ) dfinir au mieux notre compteur de boucle
		mov ebx,Taille_Structure_Etoile				;; )
		mul ebx									;; )
		sub eax,ebx								;; )
		mov Compteur_Boucle_Etoies,eax				;; )
BoucleNombreEtoiles:
		mov edi,Tampon_Etoiles._Pointeur_				;; placer le pointeur du tampon toiles dans esi
		add edi,Compteur_Boucle_Etoies				;; ajouter notre compteur de boucle  ce pointeur
		mov ecx,DWORD PTR [edi+8]					;; placer l'offset 8 (x._Z_3D_) dans ecx


;
; Verifier si l'toile est toujours valide, sinon on en cr une nouvelle :
; a ce stade, le pointeur de l'toile doit tre, et rester, dans edi
;
		cmp ecx,Vitesse_Deplacement					;; comparer la position restante (en x._Z_3D_)  la Vitesse_Deplacement
		jg FinVerificationValiditeEtoile				;; si ecx est suprieur, aller FinVerificationValiditeEtoile pour eviter la vrification
CreationNouvelleEtoile:
		mov ebx,Largeur_Ecran_Travail					;; ) gnrer un nombre alatoire pour la position cran x
		call GenererNombreAleatoire					;; )
		mov DWORD PTR [edi+16],eax					;; le placer  l'offset 16 (x._X_2D_)
		sub eax,Largeur_Ecran_Travail_Moitiee			;; soustraire la moitie de Largeur_Ecran_Travail  eax
		mov DWORD PTR [edi],eax						;; placer le rsultat  l'offset 0 (x._X_3D_)
		mov ebx,Hauteur_Ecran_Travail					;; ) gnrer un nombre alatoire pour la position cran y
		call GenererNombreAleatoire					;; )
		mov DWORD PTR [edi+20],eax					;; le placer  l'offset 20 (x._Y_2D_)
		sub eax,Hauteur_Ecran_Travail_Moitiee			;; soustraire la moitie de Hauteur_Ecran_Travail  eax
		mov DWORD PTR [edi+4],eax					;; placer le rsultat  l'offset 4 (x._Y_3D_)
		mov ecx,4096								;; placer 4096 (la profondeur)  l'offset 8 de la structure (temporairement ecx)
FinVerificationValiditeEtoile:


;
; remplacement des anciennes coordonnes 2D (pour l'effet traine)
;
		movq MM0,QWORD PTR [edi+16]					;; placer l'offset 16 (x._X_2D_) et l'offset 20 (x._Y_2D_) dans MM0
		movq QWORD PTR [edi+24],MM0					;; et le placer  l'offset 24 (x._Ancien_X_2D_) et l'offset 28 (x._Ancien_Y_2D_)


;
; Calcul des nouvelles coordonnes
; note : si on inverse les signes dans les 2 calculs, on inverse le sens de rotation
;
		sub ecx,Vitesse_Deplacement					;; soustraire Vitesse_Deplacement  l'offset 8 (Z3D)
		mov esi,DWORD PTR [edi]						;; placer l'offset 0 (x._X_3D_) dans esi
; obtenir le nouveau X => (nouveau X) = X * Cos(Angle_Z) - Y * Sin(Angle_Z) / 4096
		mov eax,DWORD PTR [edi+4]					;; placer l'offset 4 (x._Y_3D_)
		imul Sinus_Z								;; multiplier x._Y_3D_ par Sinus_Z, eax = Y*Sin(Angle_Z)
		mov ebx,eax								;; placer le rsultat obtenu dans ebx
		mov eax,esi								;; placer l'offset 4 (x._X_3D_) dans eax
		imul Cosinus_Z								;; multiplier x._X_3D_ par Cosinus_Z, eax = X*Cos(Angle_Z)
		sub eax,ebx								;; soustraire Y*Sin(Angle_Z)  X*Cos(Angle_Z)
		mov ebx,eax								;; sauvegarder le rsultat obtenu dans ebx
		sar ebx,12								;; diviser ebx par 4096 (maintenant, ebx est le nouveau X)
		mov DWORD PTR [edi],ebx						;; et on le place  l'offset 0 (x._X_3D_)
; transformation en coordonnees 2d
		cdq										;; propager le bit de signe en eax dans edx
		idiv ecx									;; division signe d'eax par l'offset 8 (x._Z_3D_)
		add eax,Largeur_Ecran_Travail_Moitiee			;; ajouter la moitie de la largeur cran  eax
		mov DWORD PTR [edi+16],eax					;; et placer le rsultat  l'offset 16 (x._X_2D_)
; obtenir le nouveau Y => (nouveau Y) = Y * Cos(Angle_Z) + X * Sin(Angle_Z) / 4096
		mov eax,esi								;; placer l'offset 4 (x._X_3D_)
		imul Sinus_Z								;; multiplier x._X_3D_ par Sinus_Z, eax = X*Sin(Angle_Z)
		mov ebx,eax								;; placer le rsultat obtenu dans ebx
		mov eax,DWORD PTR [edi+4]					;; placer l'offset 4 (x._Y_3D_) dans eax
		imul Cosinus_Z								;; multiplier x._Y_3D_ par Cosinus_Z, eax = Y*Cos(Angle_Z)
		add eax,ebx								;; ajouter X*Sin(Angle_Z)  Y*Cos(Angle_Z)
		mov ebx,eax								;; sauvegarder le rsultat obtenu dans ebx
		sar ebx,12								;; diviser ebx par 4096 (maintenant, ebx est le nouveau Y)
		mov DWORD PTR [edi+4],ebx					;; et on le place  l'offset 4 (x._Y_3D_)
; transformation en coordonnees 2d
		cdq										;; propager le bit de signe en eax dans edx
		idiv ecx									;; division signe d'eax par l'offset 8 (x._Z_3D_)
		add eax,Hauteur_Ecran_Travail_Moitiee			;; ajouter la moitie de la hauteur cran  eax
		mov DWORD PTR [edi+20],eax					;; et placer le rsultat  l'offset 20 (x._Y_2D_)
FinCalculNouvellesCoordonnees:


;
; dfinir la couleur de l'toile
;
		mov edx,ecx								;; copier ecx (x._Z_3D_) dans edx
		shr edx,4									;; dcaler edx  droite de 4 bits (pour passer de FFF  FF)
		neg edx									;; inverser la valeur
		add edx,0FFh								;; ajouter FF  cette valeur pour obtenir l'intensit de la couleur
		mov eax,000010101h							;; on place 010101h (les 3 composante de la couleur) dans eax
		mul edx									;; que l'on multipli par edx (l'intensit)
		or eax,0FF00007Fh							;; ici, c'est pour obtenir un petit effet bleut (et mettre l'alpha  fond)
		mov Couleur_Etoile,eax						;; et on sauvegarde la couleur obtenue


;
; Dessiner l'toile 
;
		mov DWORD PTR [edi+8],ecx					;; sauver ecx  l'offset 8 (x._Z_3D_)
		mov esi,OFFSET Tampon_Ecran_Travail			;; placer l'adresse de la structure Tampon_Ecran_Travail
		cmp Temoin_Afficher_Trainee,1					;; comparer Temoin_Afficher_Trainee  1
		je DessinAvecTrainee						;; si c'est gal, aller DessinAvecTrainee
;
; dessiner un point X1,Y1 (on ne dfini que le registre pour la couleur, c'est le seul qui manque)
;
		mov eax,DWORD PTR [edi+16]					;; placer l'offset 16 (x._X_2D_) dans eax
		mov ebx,DWORD PTR [edi+20]					;; placer l'offset 20 (x._Y_2D_) dans eax
		mov edi,Couleur_Etoile						;; on place la couleur
;		call DessinerPoint							;; et on dessine le point
		call Mmx_DessinerPoint_Alpha					;; et on dessine le point
		jmp EtoileDessinee							;; aller EtoileDessinee
DessinAvecTrainee:
;
; dessiner une ligne de X1,Y1  X2,Y2 (on ne dfini que le registre pour la couleur, c'est le seul qui manque)
;
		mov eax,DWORD PTR [edi+16]					;; placer l'offset 16 (x._X_2D_) dans eax
		mov ebx,DWORD PTR [edi+20]					;; placer l'offset 20 (x._Y_2D_) dans eax
		mov ecx,DWORD PTR [edi+24]					;; placer l'offset 24 (x._Ancien_X_2D_) dans eax
		mov edx,DWORD PTR [edi+28]					;; placer l'offset 28 (x._Ancien_Y_2D_) dans eax
		mov edi,Couleur_Etoile						;; on place la couleur
;		call DessinerLigne							;; et on dessine la ligne
		call Mmx_DessinerLigne_Alpha					;; et on dessine la ligne
EtoileDessinee:


;
; fin de la boucle
;
FinBoucleNombreEtoiles:
		sub Compteur_Boucle_Etoies,Taille_Structure_Etoile	;; dcrmenter notre compteur de boucle d'une structure toile
		jns BoucleNombreEtoiles						;; tant que ce n'est pas sign, aller BoucleNombreEtoiles


;
; dessiner une ligne rouge de X1,Y1  X2,Y2 (ben quoi ? je peut tester mes routines quand mme... non ?)
;
		mov eax,0									;; placer X1=0
		mov ebx,0									;; placer Y1=0
		mov ecx,Largeur_Ecran_Travail-1				;; placer X2=799 ) -1  cause du 0 (799 + le 0 =800)
		mov edx,Hauteur_Ecran_Travail-1				;; placer Y2=599 )
		mov edi,0FFFF0000h							;; on place la couleur
;		call DessinerLigne							;; et on dessine la ligne
		call Mmx_DessinerLigne_Alpha					;; et on dessine la ligne


;
; afficher le nombre d'images par secondes
;
		cmp Temoin_Des_Statistiques,0					;; on compare Temoin_Des_Statistiques  0
		je FinAffichageChaines						;; si c'est gal (rien  afficher), aller FinAffichageChaines
; ici on dfini la couleur par dfaut des textes  afficher dans l'cran (fait hors boucle, pour une question de vitesse)
		mov eax,Couleur_Jaune						;; ) dfinir les couleurs police + fond
;		mov ebx,Couleur_Rouge						;; ) (inutile si sans fond)
		call DefinirCouleursChaine					;; )
; ici on affiche la chaine
		xor eax,eax								;; position X (en pixels)
		xor ebx,ebx								;; position Y (en pixels)
		mov edx,OFFSET Police_Xx16					;; adresse de la police utilise
		mov esi,OFFSET Chaine_Images_Seconde			;; adresse de la chane  afficher
		mov edi,OFFSET Tampon_Ecran_Travail			;; placer l'adresse du Tampon_Ecran_Travail dans edi
;		call AfficherChaineSansFond					;; ) afficher cette chane  la position spcifie
;		call AfficherChaine							;; )
		call Mmx_AfficherChaineSansFond_Alpha_Turbo		;; )
FinAffichageChaines:

		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret											;; retourner (sortir de la procdure)
DessinerEtoiles endp


ALIGN 16
;
; procdure d'valuation du temps coul (sert pour les images secondes)
;
EvaluationTemps PROC HWndc:DWORD,uMsg2:DWORD,Periode_Ecoulee:DWORD,dwtime:DWORD

		cmp Periode_Ecoulee,1						;; comparer evnement priodique  1
		jne Label01								;; si c'est diffrent, aller Label01
		pushad									;; sinon, empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
		mov eax,Compteur_Des_images					;; placer le Compteur_Des_images (nombre d'images obtenues) dans eax
		mov esi,OFFSET Chaine_Nombre_Images_Seconde		;; placer l'adresse qui doit contenir la chane du nombre dans esi
		call ConvertirValeurEnChaineDecimale			;; et convertir la valeur en chane dcimale
		mov Compteur_Des_images,0					;; effacer Compteur_Des_images
		popad									;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
Label01:
	ret											;; retourner (sortir de la procdure)
EvaluationTemps ENDP


ALIGN 16
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * Processus principal -> les effets 2D de l'intro
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
ProcessusPrincipal PROC

;
; ici, on alloue les blocs mmoires ncessaires
;
		mov eax,Nombre_Etoiles*Taille_Structure_Etoile	;; ) allouer un espace mmoire pour notre tampon concernant les toiles
		mov esi,OFFSET Instance_Memoire				;; )
		mov edi,OFFSET Tampon_Etoiles					;; )
		call AllouerBlocMemoire						;; )
		mov eax,Largeur_Ecran_Travail					;;	) allouer un espace mmoire pour notre tampon ecran travail
		mov ebx,Hauteur_Ecran_Travail+2				;;	) ici on ajoute 2 (une ligne au dessus et une ligne en dessous)
		mov esi,OFFSET Instance_Memoire				;;	)
		mov edi,OFFSET Tampon_Ecran_Travail			;;	)
		call CreerEcran							;;	)
; suite  l'ajout des 2 lignes, il faut corriger quelques variables lies  la structure _Bloc_Memoire_Ecran_
		mov eax,Tampon_Ecran_Travail._Pointeur_			;; ) ici on ajoute une ligne (un dcalage ncessaire pour les effets blur)
		add eax,Tampon_Ecran_Travail._Largeur_Ecran_X4_	;; )
		mov Tampon_Ecran_Travail._Pointeur_,eax			;; )
		mov eax,Tampon_Ecran_Travail._Hauteur_Ecran_		;;	) ici on enleve les 2 lignes qu'on avait rajout pour avoir une hauteur valide
		sub eax,2									;;	)
		mov Tampon_Ecran_Travail._Hauteur_Ecran_,eax		;;	)
		mov eax,Tampon_Ecran_Travail._Taille_Du_Bloc_	;; placer la taille  effacer dans eax
		sub eax,Tampon_Ecran_Travail._Largeur_Ecran_X4_	;; ) enlever les 2 lignes (a cause des 2 lignes ajoutes) (c'est ncessaire pour eviter un crash en sortie d'app)
		sub eax,Tampon_Ecran_Travail._Largeur_Ecran_X4_	;; )
		mov Tampon_Ecran_Travail._Taille_Du_Bloc_,eax	;; )
; tester s'il y a un redimenssionnement  effectuer
		cmp Tampon_Ecran_Travail._Largeur_Ecran_,Largeur_Ecran_Final	;; comparer la largeur  celle de l'cran final
		jne DefinirTemoinRedimensionnement				;; si il y a une diffrence, aller DefinirTemoinRedimensionnement
		cmp Tampon_Ecran_Travail._Hauteur_Ecran_,Hauteur_Ecran_Final	;; comparer la hauteur  celle de l'cran final
		jne DefinirTemoinRedimensionnement				;; si il y a une diffrence, aller DefinirTemoinRedimensionnement
		mov Temoin_Redimensionnement,0				;; sinon, c'est qu'il n'y a pas de redimensionnement  faire
		jmp FinDefinirTemoinRedimensionnement			;; aller FinDefinirTemoinRedimensionnement
DefinirTemoinRedimensionnement:
		mov eax,Largeur_Ecran_Final					;; ) allouer un espace mmoire pour notre tampon ecran final
		mov ebx,Hauteur_Ecran_Final					;; )
		mov esi,OFFSET Instance_Memoire				;; )
		mov edi,OFFSET Tampon_Ecran_Final				;; )
		call CreerEcran							;; )
		mov eax,Tampon_Ecran_Travail._Largeur_Ecran_		;; placer la largeur de l'ecran travail dans eax
		shl eax,1									;; multiplier cette largeur par 2
		cmp eax,Tampon_Ecran_Final._Largeur_Ecran_		;; on compare le rsultat  la largeur de l'cran final
		jne DefinirTemoinRedimensionnement2			;; si c'est diffrent, aller DefinirTemoinRedimensionnement2
		mov eax,Tampon_Ecran_Travail._Hauteur_Ecran_		;; placer la hauteur de l'ecran travail dans eax
		shl eax,1									;; multiplier cette hauteur par 2
		cmp eax,Tampon_Ecran_Final._Hauteur_Ecran_		;; on compare le rsultat  la hauteur de l'cran final
		jne DefinirTemoinRedimensionnement2			;; si c'est diffrent, aller DefinirTemoinRedimensionnement2
		mov Temoin_Redimensionnement,1				;; sinon, il y aura un redimensionnement *2
		jmp FinDefinirTemoinRedimensionnement			;; aller FinDefinirTemoinRedimensionnement
DefinirTemoinRedimensionnement2:
		mov eax,Tampon_Ecran_Final._Largeur_Ecran_		;; ) dfinir la table de redimensionnement (la mmoire est alloue avec)
		mov ebx,Tampon_Ecran_Final._Hauteur_Ecran_		;; )
		mov ecx,Tampon_Ecran_Travail._Largeur_Ecran_		;; )
		mov edx,Tampon_Ecran_Travail._Hauteur_Ecran_		;; )
		mov esi,OFFSET Instance_Memoire				;; )
		mov edi,OFFSET Tampon_Table_Redimensionnement	;; )
		call DefinirTableDeRedimensionnement			;; )
		mov Temoin_Redimensionnement,2				;; il y aura un redimensionnement autre que *2
FinDefinirTemoinRedimensionnement:


;
; initialiser une profondeur pour le champ
;
		xor ecx,ecx								;; effacer ecx (mettre la boucle  zro)
InitialisationProfondeur:
		mov eax,Taille_Structure_Etoile				;; placer la taille d'une structure toile dans eax
		mul ecx									;; et multiplier eax par ecx (la valeur de boucle)
		add eax,Tampon_Etoiles._Pointeur_				;; ajouter le pointeur du tampon toiles  eax
		mov edi,eax								;; sauvegarder le pointeur de l'toile en cours pour la boucle dans edi
		mov ebx,4096								;; ) gnrer un nombre alatoire pour la position z
		call GenererNombreAleatoire					;; )
		mov DWORD PTR [edi+8],eax					;; le placer  l'offset 12 (x._Z_3D_)
		inc ecx									;; et l'incrmenter d'un puisque c'est la fin de la boucle
		cmp ecx,Nombre_Etoiles						;; comparer le compteur en ecx  Nombre_Etoiles
		jb InitialisationProfondeur					;; si c'est infrieur, aller InitialisationProfondeur


;
; dbut de la boucle qui sera le processus
;
DebutBoucleProcessus:


;
; on regarde si on doit appliquer l'effet blur (fondu)
;
		cmp Temoin_Effet_Fondu,1						;; l'effet blur est activ ?
		je AppliquerEffetFondu						;; si c'est le cas, aller AppliquerEffetFondu
;
; s'il n'y a pas d'effet  appliquer, alors on nettoie le tampon rserv pour l'cran
;

;		mov eax,Tampon_Ecran_Travail._Taille_Du_Bloc_	;; ) effacer l'cran (le remplir avec la couleur noire)
;		mov edi,Tampon_Ecran_Travail._Pointeur_			;; )
;		call Mmx_EffacerBlocMemoire					;; )

		mov eax,Tampon_Ecran_Travail._Taille_Du_Bloc_	;; ) casser les couleurs cran (avec la couleur noire)
		mov ebx,000000000h							;; ) (c'est un peu mieux que les lignes ci-dessus, 
		mov esi,Tampon_Ecran_Travail._Pointeur_			;; ) parceque ca donne un mini effet de traine...)
		call Mmx_CasserCouleurs						;; )


;
; et on dessine les toiles
;
		call DessinerEtoiles						;; dessin des toiles
		jmp FinEffetFondu							;; et eviter l'effet fondu, aller FinEffetFondu
AppliquerEffetFondu:
;
; on dessine les toiles
;
		call DessinerEtoiles						;; dessin des toiles
;
; ici, on applique l'effet blur appropri
;
		mov esi,OFFSET Tampon_Ecran_Travail			;; ) lire le type
		cmp Temoin_Type_Fondu,0						;; )
		je FonduLeger								;; )
		cmp Temoin_Type_Fondu,1						;; )
		je FonduStatique							;; )
		cmp Temoin_Type_Fondu,2						;; )
		je FonduDescendant							;; )
		call Mmx_EffetFonduAscendant					;; ) et application de l'effet
		jmp FinEffetFondu							;; )
FonduDescendant:									;; )
		call Mmx_EffetFonduDescendant					;; )
		jmp FinEffetFondu							;; )
FonduStatique:										;; )
		call Mmx_EffetFonduStatique					;; )
		jmp FinEffetFondu							;; )
FonduLeger:										;; )
		call Mmx_EffetFonduLeger						;; )
FinEffetFondu:										;; )


;
; redimenssionner l'cran (uniquement si ca doit tre fait)
;
		cmp Temoin_Redimensionnement,2				;; est-ce un redimensionnement autre que *2 ?
		je Redimensionnement						;; si c'est le cas, aller Redimensionnement
		cmp Temoin_Redimensionnement,1				;; est-ce un redimensionnement *2 ?
		je Redimensionnement2						;; si c'est le cas, aller Redimensionnement2
		invoke SetDIBitsToDevice,Pointeur_DC_Ecran,NULL,NULL,Tampon_Ecran_Travail._Largeur_Ecran_,Tampon_Ecran_Travail._Hauteur_Ecran_,NULL,NULL,NULL,Tampon_Ecran_Travail._Hauteur_Ecran_,Tampon_Ecran_Travail._Pointeur_,ADDR Informations_Bitmap,DIB_RGB_COLORS
		jmp FinRedimensionnement						;; aller FinRedimensionnement
Redimensionnement:
		mov eax,OFFSET Tampon_Table_Redimensionnement	;; ) redimensionnement vers l'cran final
		mov esi,Tampon_Ecran_Travail._Pointeur_			;; )
		mov edi,Tampon_Ecran_Final._Pointeur_			;; )
		call Redimensionner							;; )
		jmp Redimensionnement3						;; aller Redimensionnement3
Redimensionnement2:
		mov esi,OFFSET Tampon_Ecran_Travail			;; ) redimensionnement vers l'cran final en *2
		mov edi,OFFSET Tampon_Ecran_Final				;; )
		call Mmx_AgrandirX2_RemplissageFondu			;; )
Redimensionnement3:
		invoke SetDIBitsToDevice,Pointeur_DC_Ecran,NULL,NULL,Tampon_Ecran_Final._Largeur_Ecran_,Tampon_Ecran_Final._Hauteur_Ecran_,NULL,NULL,NULL,Tampon_Ecran_Final._Hauteur_Ecran_,Tampon_Ecran_Final._Pointeur_,ADDR Informations_Bitmap,DIB_RGB_COLORS
FinRedimensionnement:


;
; fin de la boucle
;
		inc Compteur_Des_images						;; une image de plus  t faite, on incrmente donc notre compteur
		cmp Temoin_Poursuite_Processus,0				;; comparer Temoin_Poursuite_Processus  0
		jne DebutBoucleProcessus						;; tant que Temoin_Poursuite_Processus est diffrent de 0, aller DebutBoucleProcessus


;
; librer les espaces mmoire
;
		mov esi,OFFSET Instance_Memoire				;; placer l'adresse de la structure instance mmoire dans esi
		cmp Temoin_Redimensionnement,0				;; on teste s'il y a eu un redimensionnement
		je LibererMemoireEcrans2						;; s'il n'y a pas de redimensionnement, aller LibererMemoireEcrans2
		cmp Temoin_Redimensionnement,1				;; on teste s'il y a eu un redimensionnement *2
		je LibererMemoireEcrans						;; s'il n'y a pas de redimensionnement, aller LibererMemoireEcrans
		mov edi,OFFSET Tampon_Table_Redimensionnement	;; ) supprimer l'espace mmoire pour la table de redimensionnement
		call SupprimerTableDeRedimensionnement			;; )
LibererMemoireEcrans:
		mov edi,OFFSET Tampon_Ecran_Final				;; ) supprimer l'espace mmoire pour l'ecran final
		call SupprimerEcran							;; )
LibererMemoireEcrans2:
		mov edi,OFFSET Tampon_Ecran_Travail			;; ) supprimer l'espace mmoire pour l'ecran travail
		call SupprimerEcran							;; )
		mov edi,OFFSET Tampon_Etoiles					;;	) supprimer l'espace mmoire pour notre tampon toiles
		call LibererBlocMemoire						;;	)
		call SupprimerInstanceMemoire					;; ) supprimer l'intance mmoire


;
; terminer le processus
;
		mov Temoin_Poursuite_Processus,-1				;; processus dfinitivement clos

;	ret											;; ATTENTION !!! a ne pas activer pour un processus
ProcessusPrincipal ENDP


ALIGN 16
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * Point d'entre du programme
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Starfield:

;
; la procdure principale (la seule (avec les processus) qui ne ncessite pas un ret  la sortie)
;
ProgrammePrincipal PROC
;		invoke GetCurrentProcess						;; ) fixer la priorit de notre application  haute
;		invoke SetPriorityClass,eax,HIGH_PRIORITY_CLASS	;; )
		invoke GetCommandLine						;;	) obtenir un pointeur sur la ligne de commande
		mov Pointeur_Ligne_Commande,eax				;;	) et sauvegarder ce pointeur dans Pointeur_Ligne_Commande
		invoke GetModuleHandle,NULL					;; ) obtenir l'instance de la fentre
		mov Instance_Application,eax					;; ) et sauvegarder le pointeur obtenu dans Instance_Application
		mov Informations_Fenetre.hInstance,eax			;; ) ainsi que dans notre structure WNDCLASSEX
		invoke GetModuleHandle,NULL					;;	) obtenir l'instance des boites de dialogue
		mov Instance_Boite_Dialogue,eax				;;	) et sauvegarder le pointeur obtenu dans Instance_Boite_Dialogue
		invoke ShowCursor,FALSE						;; faire disparaitre le pointeur cran
		mov esi,OFFSET Instance_Memoire				;; ) obtenir une instance mmoire
		call CreerInstanceMemoire					;; )
		call InitialiserNombresAleatoires				;; Initialiser les nombres aleatoires avec le nombre de millisecondes coules depuis le dmarrage de l'ordinateur.


;
; centrer la position de notre cran (pour le cas o celui-ci est infrieur  l'cran OS)
;
		invoke GetSystemMetrics,SM_CXSCREEN			;; obtenir la taille x de l'ecran os (en pixels)
		sub eax,Largeur_Ecran_Final					;; soustraire la largeur de notre ecran final
		sar eax,1									;; diviser ensuite ce resultat par 2
		mov Position_Ecran_X,eax						;; et placer le rsultat dans Position_Ecran_X
		invoke GetSystemMetrics,SM_CYSCREEN			;; obtenir la taille y de l'ecran os (toujours en pixels)
		sub eax,Hauteur_Ecran_Final					;; soustraire la hauteur de notre cran final
		sar eax,1									;; diviser ensuite ce resultat par 2
		mov Position_Ecran_Y,eax						;; et placer le rsultat dans Position_Ecran_Y


;
; remplir la structure BITMAPINFO avec les variables reuises
;
		mov Informations_Bitmap.biSize,SIZEOF BITMAPINFOHEADER	;; taille de la structure BITMAPINFOHEADER
		mov Informations_Bitmap.biWidth,Largeur_Ecran_Final	;; la largeur
		mov Informations_Bitmap.biHeight,-Hauteur_Ecran_Final	;; la hauteur (ngative, pour que la premire ligne soit celle du haut, et pas celle du bas)
		mov Informations_Bitmap.biPlanes,1				;;
		mov Informations_Bitmap.biBitCount,32			;; pour des couleurs 32 bits
		mov Informations_Bitmap.biCompression,BI_RGB		;; (BI_RGB=pas de compression)


;
; remplir la structure WNDCLASSEX avec les variables requises, et cration de l'cran
;
		invoke LoadIcon,Instance_Application,500		;; pointeur sur l'icone (500 = ID de l'icne)
		mov Informations_Fenetre.hIcon,eax				;; sauver le pointeur
		invoke LoadCursor,NULL,IDC_ARROW
		mov Informations_Fenetre.hCursor,eax
; remplir le reste de la structure WNDCLASSEX avec les variables requises
		mov Informations_Fenetre.cbSize,SIZEOF WNDCLASSEX
		mov Informations_Fenetre.style,CS_BYTEALIGNCLIENT or CS_NOCLOSE
		mov Informations_Fenetre.lpfnWndProc,OFFSET GestionnaireMessages
		mov Informations_Fenetre.cbClsExtra,NULL
		mov Informations_Fenetre.cbWndExtra,NULL
		mov Informations_Fenetre.hbrBackground,COLOR_WINDOWTEXT
		mov Informations_Fenetre.lpszMenuName,NULL
		mov Informations_Fenetre.lpszClassName,OFFSET Chaine_Type_Fenetre
		mov Informations_Fenetre.hIconSm,0
		invoke RegisterClassEx,ADDR Informations_Fenetre
; maintenant que tous les parametres sont dfinis, on cr l'cran
		invoke CreateWindowEx,WS_EX_LEFT,ADDR Chaine_Type_Fenetre,ADDR Chaine_Titre_Fenetre,WS_POPUP,Position_Ecran_X,Position_Ecran_Y,Largeur_Ecran_Final,Hauteur_Ecran_Final,NULL,NULL,Instance_Application,NULL
		mov Pointeur_Fenetre,eax


;
; ici, on va tester le microprocesseur pour savoir si le minimum requis est disponible (on l'a pas fait avant parcequ'il fallait Pointeur_Fenetre)
;
		call DefinirAptitudesDuProcesseur
; bit 0 = Cpuid support ? 1=oui, 0=non
; bit 1 = Fpu support ? 1=oui, 0=non
; bit 2 = Tsc support ? 1=oui, 0=non
; bit 3 = Cx8 support ? 1=oui, 0=non
; bit 4 = cMov support ? 1=oui, 0=non
; bit 5 = Clfsh support ? 1=oui, 0=non
; bit 6 = Mmx support ? 1=oui, 0=non
; bit 7 = Fxsr support ? 1=oui, 0=non
; bit 8 = Sse support ? 1=oui, 0=non
; bit 9 = Sse2 support ? 1=oui, 0=non
; bit 10 = Htt support ? 1=oui, 0=non
; bit 11 = Sse3 support ? 1=oui, 0=non
		mov eax,Temoins_Aptitudes_Du_MicroProcesseur		;; copier les tmoins obtenus dans eax
;		mov edx,000000000001b						;; cpuid
;		mov edx,000000000011b						;; cpuid + fpu
;		mov edx,000000010011b						;; cpuid + fpu + cmov
;		mov edx,000001010011b						;; cpuid + fpu + cmov + mmx
		mov edx,000101010011b						;; cpuid + fpu + cmov + mmx + sse
;		mov edx,001101010011b						;; cpuid + fpu + cmov + mmx + sse + sse2
;		mov edx,101101010011b						;; cpuid + fpu + cmov + mmx + sse + sse2 + sse3
		and eax,edx								;; ici on ne conserve que les bits  tester dans eax
		cmp eax,edx								;; et on s'asure qu'ils sont tous l
		je MicroprocesseurSuffisant					;; si c'est gal (le microprocesseur a le minimum requis), aller MicroprocesseurSuffisant
; sinon on va afficher la boite de dialogue en consquence
		invoke ShowCursor,TRUE						;; faire rapparaitre le pointeur cran
		invoke DialogBoxParam,Instance_Boite_Dialogue,ADDR Chaine_Boite_Dialogue_Insuffisant,0,ADDR GestionnaireMessagesBoiteDialogue,0
; boucle a effectuer tant que le message envoy par PostQuitMessage n'a pas t reu
MicroprocesseurBoucleMessages:
;		invoke GetMessage,ADDR Informations_Messages_OS,Vide,Vide,Vide	;; pour obtenir les messages provenants de toutes les applications
		invoke GetMessage,ADDR Informations_Messages_OS,Pointeur_Fenetre,NULL,NULL	;; pour obtenir uniquement les messages concernant notre application
		cmp eax,NULL								;; comparer eax  zro
		je MicroprocesseurInsuffisant					;; si c'est gal  0 (pas de message), aller MicroprocesseurInsuffisant
;		invoke TranslateMessage,ADDR Informations_Messages_OS	;; (optionnel) pour traduire les messages des touches du clavier
		invoke DispatchMessage,ADDR Informations_Messages_OS	;; et dispatcher (mettre  la queue pour que ce soit lu par GestionnaireMessages au moment voulu)
		jmp MicroprocesseurBoucleMessages				;; aller MicroprocesseurBoucleMessages (pour aller lire le message suivant)
MicroprocesseurSuffisant:


;
; sinon, le minimum requis est prsent, alors on cr un pointeur pour le device context
;

;
; on cr un pointeur pour le device context
;
		invoke GetDC,Pointeur_Fenetre
		mov Pointeur_DC_Ecran,eax


;
; dfinir et lancer le processus principal
;
		invoke CreateThread,NULL,Taille_Pile_Processus_Principal*1024,ADDR ProcessusPrincipal,Pointeur_Fenetre,NULL,ADDR Pointeur_Processus_Principal
		mov Pointeur_Processus_Principal,eax				;; sauvegarder le pointeur obtenu
		invoke SetThreadPriority,Pointeur_Processus_Principal,THREAD_PRIORITY_NORMAL	;; laisser la priorit du processus  la normale THREAD_PRIORITY_LOWEST, THREAD_PRIORITY_BELOW_NORMAL, THREAD_PRIORITY_NORMAL, THREAD_PRIORITY_ABOVE_NORMAL, THREAD_PRIORITY_HIGHEST
		mov Temoin_Poursuite_Processus,1				;; le processus est maintenant actif

		invoke ShowWindow,Pointeur_Fenetre,SW_SHOWNORMAL
		invoke UpdateWindow,Pointeur_Fenetre
		invoke SetTimer,Pointeur_Fenetre,1,1000,OFFSET EvaluationTemps


;
; boucle a effectuer tant que le message PostQuitMessage n'a pas t reu
;
BoucleMessages:
		invoke GetMessage,ADDR Informations_Messages_OS,Pointeur_Fenetre,NULL,NULL
		cmp eax,NULL
		je FinBoucleMessages
		invoke TranslateMessage,ADDR Informations_Messages_OS
		invoke DispatchMessage,ADDR Informations_Messages_OS
		jmp BoucleMessages
FinBoucleMessages:


;
; par ici la sortie...
;
		invoke SetThreadPriority,Pointeur_Processus_Principal,THREAD_PRIORITY_NORMAL	;; baisser la priorit du processus... THREAD_PRIORITY_LOWEST, THREAD_PRIORITY_BELOW_NORMAL, THREAD_PRIORITY_NORMAL, THREAD_PRIORITY_ABOVE_NORMAL, THREAD_PRIORITY_HIGHEST
		invoke TerminateThread,Pointeur_Processus_Principal,0	;; terminer le processus
		invoke DeleteDC,Pointeur_DC_Ecran				;; supprimer le device context
		invoke ShowCursor,TRUE						;; faire rapparaitre le pointeur cran
MicroprocesseurInsuffisant:
;		invoke GetCurrentProcess						;;	) remettre la priorit du programme  la normale
;		invoke SetPriorityClass,eax,NORMAL_PRIORITY_CLASS	;;	)
		invoke ExitProcess,Informations_Messages_OS.wParam	;; sortie de l'application
ProgrammePrincipal ENDP


ALIGN 16
;
; ici, on inclus l'indispensable procdure de gestion des messages entre l'application et windows...
;
GestionnaireMessages PROC HWndGM:DWORD,Message:DWORD,WParam:DWORD,LParam:DWORD
;LOCAL DessinEcran :PAINTSTRUCT

		cmp Temoin_Poursuite_Processus,-1				;; le processus est arrt ?
		jne GMPasFinApplication						;; si ce n'est pas le cas, aller GMPasFinApplication
		invoke PostQuitMessage,NULL					;; sinon, poster le message de sortie
		xor eax,eax								;; remettre eax  zro
	ret											;; retourner
ALIGN 16
GMPasFinApplication:
		mov eax,Message							;; placer Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)

; initialisation de la fentre
;		cmp eax,WM_CREATE
;		jne GMFinInitialisation						;; sinon, aller GMFinInitialisation
;
;	ret											;; retourner
;ALIGN 16
;GMFinInitialisation:

;; dessin de la fentre
;		cmp eax,WM_PAINT
;		jne GMFinMiseAJourEcran						;; sinon, aller GMFinMiseAJourEcran
;		invoke BeginPaint,HWndGM,ADDR DessinEcran
;		mov hDC,eax
;		invoke EndPaint,HWndGM,ADDR DessinEcran
;	Retourner 0									;; retourner
;ALIGN 16
;GMFinMiseAJourEcran:

;;
;; fermeture de l'application ?
;;
;		cmp eax,WM_CLOSE							;; message de fermeture reu ?
;		jne GMFinFermeture							;; si ce n'est pas le cas, aller GMFinFermeture
;		mov Temoin_Poursuite_Processus,0				;; sinon, on place 0 dans Temoin_Poursuite_Processus
;		xor eax,eax								;; remettre eax  zro
;	ret											;; retourner
;ALIGN 16
;GMFinFermeture:

;
; fin du processus principal
;
		cmp eax,WM_DESTROY							;; fermeture de l'application par la croix ?
		jne GMFinProcessusTermine					;; si ce n'est pas le cas, aller GMFinProcessusTermine
		mov Temoin_Poursuite_Processus,0				;; sinon, on place 0 dans Temoin_Poursuite_Processus
		xor eax,eax								;; remettre eax  zro
	ret											;; retourner
ALIGN 16
GMFinProcessusTermine:
;
; les messages :
; WM_LBUTTONDOWN, WM_LBUTTONUP, WM_LBUTTONDBLCLK,
; WM_MBUTTONDOWN, WM_MBUTTONUP, WM_MBUTTONDBLCLK,
; WM_RBUTTONDOWN, WM_RBUTTONUP, WM_RBUTTONDBLCLK, WM_MOUSEMOVE
; retournent le rsultat obtenu par les boutons et le mouvement de la souris.
;
		cmp eax,WM_LBUTTONDOWN						;; bouton gauche de la souris press ?
		jne GMPasBoutonSourisGauche					;; si c'est diffrent, aller GMPasBoutonSourisGauche
		mov Temoin_Bouton_Souris_Gauche,1
	ret											;; retourner
ALIGN 16
GMPasBoutonSourisGauche:
;
		cmp eax,WM_LBUTTONUP						;; bouton gauche de la souris non press ?
		jne GMBoutonSourisGauche						;; si c'est diffrent, aller GMBoutonSourisGauche
		mov Temoin_Bouton_Souris_Gauche,0
	ret											;; retourner
ALIGN 16
GMBoutonSourisGauche:
;;
;		cmp eax,WM_LBUTTONDBLCLK						;; bouton gauche de la souris double clique ?
;		jne GMPasBoutonSourisGaucheDouble				;; si c'est diffrent, aller GMPasBoutonSourisGaucheDouble
;
;	ret											;; retourner
;ALIGN 16
;GMPasBoutonSourisGaucheDouble:
;
		cmp eax,WM_MBUTTONDOWN						;; bouton milieu de la souris press ?
		jne GMPasBoutonSourisMilieu					;; si c'est diffrent, aller GMPasBoutonSourisMilieu
		mov Temoin_Bouton_Souris_Milieu,1
	ret											;; retourner
ALIGN 16
GMPasBoutonSourisMilieu:
;
		cmp eax,WM_MBUTTONUP						;; bouton milieu de la souris non press ?
		jne GMBoutonSourisMilieu						;; si c'est diffrent, aller GMBoutonSourisMilieu
		mov Temoin_Bouton_Souris_Milieu,0
	ret											;; retourner
ALIGN 16
GMBoutonSourisMilieu:
;;
;		cmp eax,WM_MBUTTONDBLCLK						;; bouton milieu de la souris double clique ?
;		jne GMPasBoutonSourisMilieuDouble				;; si c'est diffrent, aller GMPasBoutonSourisMilieuDouble
;
;	ret											;; retourner
;ALIGN 16
;GMPasBoutonSourisMilieuDouble:
;
		cmp eax,WM_RBUTTONDOWN						;; bouton droit de la souris press ?
		jne GMPasBoutonSourisDroit					;; si c'est diffrent, aller GMPasBoutonSourisDroit
		mov Temoin_Bouton_Souris_Droit,1
	ret											;; retourner
ALIGN 16
GMPasBoutonSourisDroit:
;
		cmp eax,WM_RBUTTONUP						;; bouton droit de la souris non press ?
		jne GMBoutonSourisDroit						;; si c'est diffrent, aller GMBoutonSourisDroit
		mov Temoin_Bouton_Souris_Droit,0
	ret											;; retourner
ALIGN 16
GMBoutonSourisDroit:
;;
;		cmp eax,WM_RBUTTONDBLCLK						;; bouton droit de la souris double clique ?
;		jne GMPasBoutonSourisDroitDouble				;; si c'est diffrent, aller GMPasBoutonSourisDroitDouble
;
;	ret											;; retourner
;ALIGN 16
;GMPasBoutonSourisDroitDouble:

;
; mouvement de la souris ?
;
		cmp eax,WM_MOUSEMOVE						;; un mouvement de la souris ?
		jne GMPasMouvementsSouris					;; si ce n'est pas le cas, aller GMPasMouvementsSouris
; ici, on traite la rotation par rapport  l'axe Y (mouvement souris X)
		mov eax,LParam								;; sinon on place LParam (Y (word), X (word)) dans eax
		and eax,00000FFFFh							;; filtrer eax (pour avoir uniquement le X)
		mov Mouvement_Souris_X,eax					;; sauvegarder le rsultat dans Mouvement_Souris_X (peut tre plac ici, puisque ca ne modifie pas les flags)
; ici, on traite la rotation par rapport  l'axe X (mouvement souris Y)
		mov eax,LParam								;; sinon on place LParam (Y (word), X (word)) dans eax
		shr eax,16								;; dcaler eax  droite de 16 bits (pour avoir l'Y au bon endroit)
		mov Mouvement_Souris_Y,eax					;; sauvegarder le rsultat dans Mouvement_Souris_Y (peut tre plac ici, puisque ca ne modifie pas les flags)
;		mov eax,WParam								;; pas utile pour le moment...

	ret											;; retourner
ALIGN 16
GMPasMouvementsSouris:
	

;
; ici, les messages concernant les touches prsses
;

; touche presse ?
		cmp eax,WM_KEYDOWN
		jne GMFinTouchePressee						;; sinon, aller GMFinTouchePressee
		mov eax,WParam

; Quitter ?
		cmp eax,VK_ESCAPE							;; Quitter ?
		jne GMPasToucheQuitter						;; sinon, aller GMPasToucheQuitter
; faire rapparaitre le pointeur cran
		invoke ShowCursor,TRUE						;; faire rapparaitre le pointeur cran
		invoke DialogBoxParam,Instance_Boite_Dialogue,ADDR Chaine_Boite_Dialogue_Quitter,0,ADDR GestionnaireMessagesBoiteDialogue,0
; faire disparaitre le pointeur cran
		invoke ShowCursor,FALSE						;; faire disparaitre le pointeur cran
	ret											;; retourner
ALIGN 16
GMPasToucheQuitter:
;ALIGN 16
;; F1 ?
;		cmp eax,VK_F1
;		jne GMPasToucheF1Pressee						;; sinon, aller GMPasToucheF1Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheF1Pressee:
;; F2 ?
;		cmp eax,VK_F2
;		jne GMPasToucheF2Pressee						;; sinon, aller GMPasToucheF2Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheF2Pressee:
;; F3 ?
;		cmp eax,VK_F3
;		jne GMPasToucheF3Pressee						;; sinon, aller GMPasToucheF3Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheF3Pressee:
;; F4 ?
;		cmp eax,VK_F4
;		jne GMPasToucheF4Pressee						;; sinon, aller GMPasToucheF4Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheF4Pressee:
; F5 ?
		cmp eax,VK_F5
		jne GMPasToucheF5Pressee						;; sinon, aller GMPasToucheF5Pressee
		mov Temoin_Type_Fondu,0
	ret
ALIGN 16
GMPasToucheF5Pressee:
; F6 ?
		cmp eax,VK_F6
		jne GMPasToucheF6Pressee						;; sinon, aller GMPasToucheF6Pressee
		mov Temoin_Type_Fondu,1
	ret
ALIGN 16
GMPasToucheF6Pressee:
; F7 ?
		cmp eax,VK_F7
		jne GMPasToucheF7Pressee						;; sinon, aller GMPasToucheF7Pressee
		mov Temoin_Type_Fondu,2
	ret											;; retourner
ALIGN 16
GMPasToucheF7Pressee:
; F8 ?
		cmp eax,VK_F8
		jne GMPasToucheF8Pressee						;; sinon, aller GMPasToucheF8Pressee
		mov Temoin_Type_Fondu,3
	ret											;; retourner
ALIGN 16
GMPasToucheF8Pressee:
;; F9 ?
;		cmp eax,VK_F9
;		jne GMPasToucheF9Pressee						;; sinon, aller GMPasToucheF9Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheF9Pressee:
;; F10 ?
;		cmp eax,VK_F10
;		jne GMPasToucheF10Pressee					;; sinon, aller GMPasToucheF10Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheF10Pressee:
;; F11 ?
;		cmp eax,VK_F11
;		jne GMPasToucheF11Pressee					;; sinon, aller GMPasToucheF11Pressee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheF11Pressee:
;; F12 ?
;		cmp eax,VK_F12
;		jne GMPasToucheF12Pressee					;; sinon, aller GMPasToucheF12Pressee
;		not ModeAuto
;	ret											;; retourner
;ALIGN 16
;GMPasToucheF12Pressee:
; haut ?
		cmp eax,VK_UP								;; touche haut ?
		jne GMPasToucheHaut							;; sinon eviter les lignes suivantes
		mov eax,Vitesse_Deplacement_Maximale			;; placer Vitesse_Deplacement_Maximale dans eax
		cmp eax,Vitesse_Deplacement					;; et la comparer  Vitesse_Deplacement
		je GMEviterIncrementerVitesseDeplacement		;; si c'est gal, aller GMEviterIncrementerVitesseDeplacement
		add Vitesse_Deplacement,Vitesse_Acceleration		;; incrmenter la Vitesse_Deplacement
GMEviterIncrementerVitesseDeplacement:
	ret											;; retourner
ALIGN 16
GMPasToucheHaut:
; bas ?
		cmp eax,VK_DOWN							;; touche bas ?
		jne GMPasToucheBas							;; sinon eviter les lignes suivantes
		mov eax,Vitesse_Deplacement_Minimale			;; placer Vitesse_Deplacement_Minimale dans eax
		cmp eax,Vitesse_Deplacement					;; et la comparer  Vitesse_Deplacement
		je GMEviterDecrementerVitesseDeplacement		;; si c'est gal, aller GMEviterDecrementerVitesseDeplacement
		sub Vitesse_Deplacement,Vitesse_Deceleration		;; dcrmenter la Vitesse_Deplacement
GMEviterDecrementerVitesseDeplacement:
	ret											;; retourner
ALIGN 16
GMPasToucheBas:
; droite ?
		cmp eax,VK_RIGHT							;; touche droite ?
		jne GMPasToucheDroite						;; sinon eviter les lignes suivantes
		mov eax,Angle_Z_Maximal						;; placer Angle_Z_Maximal dans eax
		cmp eax,Angle_Z							;; et la comparer  Angle_Z
		je GMEviterIncrementerRotation				;; si c'est gal, aller GMEviterIncrementerVitesse
		add Angle_Z,16								;; incrmenter Angle_Z
GMEviterIncrementerRotation:
	ret											;; retourner
ALIGN 16
GMPasToucheDroite:
; gauche ?
		cmp eax,VK_LEFT							;; touche gauche ?
		jne GMPasToucheGauche						;; sinon eviter les lignes suivantes
		mov eax,Angle_Z_Minimal						;; placer Angle_Z_Minimal dans eax
		cmp eax,Angle_Z							;; et la comparer  Angle_Z
		je GMEviterDecrementerRotation				;; si c'est gal, aller GMEviterDecrementerVitesse
		sub Angle_Z,16								;; dcrmenter Angle_Z
GMEviterDecrementerRotation:
	ret											;; retourner
ALIGN 16
GMPasToucheGauche:
; b ?
		cmp eax,VK_B
		jne GMPasToucheBPressee						;; sinon, aller GMPasToucheBPressee
		xor Temoin_Effet_Fondu,1
	ret											;; retourner
ALIGN 16
GMPasToucheBPressee:
; s ?
		cmp eax,VK_S
		jne GMPasToucheSPressee						;; sinon, aller GMPasToucheSPressee
		xor Temoin_Des_Statistiques,1
	ret											;; retourner
ALIGN 16
GMPasToucheSPressee:
; t ?
		cmp eax,VK_T								;; touche T ?
		jne GMPasToucheTPressee						;; sinon eviter les lignes suivantes
		xor Temoin_Afficher_Trainee,1
	ret											;; retourner
ALIGN 16
GMPasToucheTPressee:
;


	ret											;; retourner
ALIGN 16
GMFinTouchePressee:

;;
;; ici, les messages concernant les touches relaches
;;
;
;; touche relache ?
;		cmp eax,WM_KEYUP
;
;		jne GMFinToucheRelachee
;		mov eax,WParam
;
;; gauche ?
;		cmp eax,VK_LEFT
;		jne GMPasToucheGaucheRelachee					;; sinon, aller GMPasToucheGaucheRelachee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheGaucheRelachee:
;; droite ?
;		cmp eax,VK_RIGHT
;		jne GMPasToucheDroiteRelachee					;; sinon, aller GMPasToucheDroiteRelachee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheDroiteRelachee:
;; haut ?
;		cmp eax,VK_UP
;		jne GMPasToucheHautRelachee					;; sinon, aller GMPasToucheHautRelachee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheHautRelachee:
;; bas ?
;		cmp eax,VK_DOWN
;		jne GMPasToucheBasRelachee					;; sinon, aller GMPasToucheBasRelachee
;
;	ret											;; retourner
;ALIGN 16
;GMPasToucheBasRelachee:
;
;
;	ret											;; retourner
;ALIGN 16
;GMFinToucheRelachee:


;
; on finit avec le traitement par dfaut
;
		invoke DefWindowProc,HWndGM,Message,WParam,LParam
	ret
GestionnaireMessages ENDP


ALIGN 16
;
; gestionnaire des messages par boites de dialogue
;
GestionnaireMessagesBoiteDialogue PROC HWndDlg:HWND,Message:UINT,WParam:WPARAM,LParam:LPARAM

		mov eax,Message							;; placer Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)


		cmp eax,WM_COMMAND
		jne GMBDFinCommandes
		mov eax,WParam								;; placer WParam en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)

;
; boite de dialogue pour microprocesseur insuffisant
;

; Il est temps d'en changer...
		cmp eax,1002								;; Hum... oui est cliqu ?
		jne GMBDPasTempsChangerMicro					;; si c'est diffrent, aller GMBDPasTempsChangerMicro
		invoke EndDialog,HWndDlg,0					;; sinon, fermer la boite de dialogue
		invoke PostQuitMessage,NULL					;; poster le message de sortie
		xor eax,eax								;; remettre eax  zro
	ret											;; retourner
ALIGN 16
GMBDPasTempsChangerMicro:

;
; boite de dialogue pour quitter le programme
;

; hum... oui
		cmp eax,1012								;; Hum... oui est cliqu ?
		jne GMBDPasHumOui							;; si c'est diffrent, aller GMBDPasHumOui
		mov Temoin_Poursuite_Processus,0				;; stoper le processus en cours
		invoke EndDialog,HWndDlg,0					;; sinon, fermer la boite de dialogue
		xor eax,eax								;; remettre eax  zro
	ret											;; retourner
ALIGN 16
GMBDPasHumOui:

; Ah a non !
		cmp eax,1013								;; Ah a non ! est cliqu ?
		jne GMBDPasAhCaNon							;; si c'est diffrent, aller GMBDPasAhCaNon
		invoke EndDialog,HWndDlg,0					;; sinon, fermer la boite de dialogue
	ret											;; retourner
ALIGN 16
GMBDPasAhCaNon:


;
; traitement par dfaut pour les boites de dialogue
;
GMBDFinCommandes:
		xor eax,eax								;; effacer eax (ce sera le traitement par dfaut des messages)
	ret											;; retourner
GestionnaireMessagesBoiteDialogue ENDP




;
; fin du programme
;
END Starfield









ALIGN 16
;
; rotation d'un point autour des axes x,y,z... (attention, edi doit contenir le pointeur du dbut de la coordonne 3D)
;
RotationPoint3D PROC
		push ebx									;; empiler ebx
		push ecx									;; empiler ecx
		push edx									;; empiler edx

; rotation autour de l'axe X
; Position_Y = Position_Y*Cos(Angle_X)-Position_Z*Sin(Angle_X)/4096
; Position_Z = Position_Y*Sin(Angle_X)+Position_Z*Cos(Angle_X)/4096
		mov eax,[edi+DWORD]							;; placer le dword  l'adresse en edi+4 (Position_Y) dans eax
		imul Cosinus_X								;; eax = Position_Y * Cos(Angle_X)
		mov ebx,eax								;; sauvegarder le rsultat en ebx
		mov eax,[edi+DWORD+DWORD]					;; placer le dword  l'adresse en edi+8 (Position_Z) dans eax
		imul Sinus_X								;; eax = Position_Z * Sin(Angle_X)
		sub ebx,eax								;; ebx = Position_Y * Cos(Angle_X) - Position_Z * Sin(Angle_X)
		sar ebx,12								;; ebx = Position_Y * Cos(Angle_X) - Position_Z * Sin(Angle_X) / 4096
		mov ecx,ebx								;; sauvegarder le rsultat en ecx

		mov eax,[edi+DWORD]							;; placer le dword  l'adresse en edi+4 (Position_Y) dans eax
		imul Sinus_X								;; eax = Position_Y * Sin(Angle_X)
		mov ebx,eax								;; sauvegarder le rsultat en ebx
		mov eax,[edi+DWORD+DWORD]					;; placer le dword  l'adresse en edi+8 (Position_Z) dans eax
		imul Cosinus_X								;; eax = Position_Z * Cos(Angle_X)
		add ebx,eax								;; ebx = Position_Y * Sin(Angle_X) + Position_Z * Cos(Angle_X)
		sar ebx,12								;; ebx = Position_Y * Sin(Angle_X) + Position_Z * Cos(Angle_X) / 4096

		mov Position_Z,ebx							;; sauvegarder le Position_Z calcul
		mov Position_Y,ecx							;; sauvegarder le Position_Y calcul
; rotation autour de l'axe Y
; Position_X = Position_X*Cos(Angle_Y)-Position_Z*Sin(Angle_Y)/4096
; Position_Z = Position_X*Sin(Angle_Y)+Position_Z*Cos(Angle_Y)/4096
		mov eax,[edi]								;; placer le dword  l'adresse en edi (Position_X) dans eax
		imul Cosinus_Y								;; eax = Position_X * Cos(Angle_Y)
		mov ebx,eax								;; sauvegarder le rsultat en ebx
		mov eax,Position_Z							;; placer le Position_Z partiellement calcul dans eax
		imul Sinus_Y								;; eax = Position_Z * Sin(Angle_Y)
		sub ebx,eax								;; ebx = Position_X * Cos(Angle_Y) - Position_Z * Sin(Angle_Y)
		sar ebx,12								;; ebx = Position_X * Cos(Angle_Y) - Position_Z * Sin(Angle_Y) / 4096
		mov ecx,ebx								;; sauvegarder le rsultat en ecx

		mov eax,[edi]								;; placer le dword  l'adresse en edi (Position_X) dans eax
		imul Sinus_Y								;; eax = Position_X * Sin(Angle_Y)
		mov ebx,eax								;; sauvegarder le rsultat en ebx
		mov eax,Position_Z							;; placer le Position_Z partiellement calcul dans eax
		imul Cosinus_Y								;; eax = Position_Z * Cos(Angle_Y)
		add ebx,eax								;; ebx = Position_X * Sin(Angle_Y) + Position_Z * Cos(Angle_Y)
		sar ebx,12								;; ebx = Position_X * Sin(Angle_Y) + Position_Z * Cos(Angle_Y) / 4096

		mov Position_Z,ebx							;; sauvegarder le Position_Z calcul
		mov Position_X,ecx							;; sauvegarder le Position_X calcul
; rotation autour de l'axe Position_Z
; Position_X = Position_X*Cos(Angle_Z)-Position_Y*Sin(Angle_Z)/4096
; Position_Y = Position_X*Sin(Angle_Z)+Position_Y*Cos(Angle_Z)/4096
		mov eax,Position_X							;; placer le Position_X partiellement calcul dans eax
		imul Cosinus_Z								;; eax = Position_X * Cos(Angle_Z)
		mov ebx,eax								;; sauvegarder le rsultat en ebx
		mov eax,Position_Y							;; placer le Position_Y partiellement calcul dans eax
		imul Sinus_Z								;; eax = Position_Y * Sin(Angle_Z)
		sub ebx,eax								;; ebx = Position_X * Cos(Angle_Z) - Position_Y * Sin(Angle_Z)
		sar ebx,12								;; ebx = Position_X * Cos(Angle_Z) - Position_Y * Sin(Angle_Z) / 4096
		mov ecx,ebx								;; sauvegarder le rsultat en ecx


		mov eax,Position_X							;; placer le Position_X partiellement calcul dans eax
		imul Sinus_Z								;; eax = Position_X * Sin(Angle_Z)
		mov ebx,eax								;; sauvegarder le rsultat en ebx
		mov eax,Position_Y							;; placer le Position_Y partiellement calcul dans eax
		imul Cosinus_Z								;; eax = Position_Y * Cos(Angle_Z)
		add ebx,eax								;; ebx = Position_X * Sin(Angle_Z) + Position_Y * Cos(Angle_Z)
		sar ebx,12								;; ebx = Position_X * Sin(Angle_Z) + Position_Y * Cos(Angle_Z) / 4096

		mov Position_Y,ebx							;; sauvegarder le Position_Y calcul
		mov Position_X,ecx							;; sauvegarder le Position_X calcul

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
		pop ebx									;; dsempiler ebx
	ret
RotationPoint3D ENDP


ALIGN 16
;
; transformation des coordonnes 3D en coordonnes 2D...
; c'est aprs cette procdure qu'il faudra traiter les X en dwords
;
DefinirCoordonnees2DPoint3D PROC
		push ecx									;; empiler ecx
		push edx									;; empiler edx

		mov ebx,Position_Z							;; placer la coordonne Position_Z dans ebx
		add ebx,Deplacement_Z						;; ajouter un (ventuel) dplacement sur l'axe Z
		add ebx,Focale_Z							;; ajouter la distance sur l'axe Z
;		js Label1									;; si Z est sign, il n'apparaitra pas  l'cran, alors aller Label1
		mov ecx,ebx								;; copier le rsultat obtenu dans dans ecx
; on calcul le Position_Y = Focale_Y * Position_Y / Position_Z + Focale_Z
		mov eax,Position_Y							;; placer Position_Y dans eax
		add eax,Deplacement_Y						;; ajouter un (ventuel) dplacement sur l'axe Y
		imul Focale_Y								;; multiplier Position_Y + Deplacement_Y par Focale_Y (la distance)
;		cdq										;; propager le bit de signe en eax dans edx
		idiv ebx									;; diviser Focale_Y * Position_Y + Deplacement_Y par Focale_Z + Position_Z + Deplacement_Z
		add eax,Hauteur_Ecran_Travail_Moitiee				;; ajouter le centre de l'axe Y au rsultat en eax
		mov ebx,eax								;; placer la coordonne dans ebx
; on calcul le Position_X = Focale_X * Position_X / Position_Z + Focale_Z
		mov eax,Position_X							;; placer Position_X dans eax
		add eax,Deplacement_X						;; ajouter un (ventuel) dplacement sur l'axe X
		imul Focale_X								;; multiplier Position_X + Deplacement_X par Focale_X (la distance)
;		cdq										;; propager le bit de signe en eax dans edx
		idiv ecx									;; diviser Focale_X * Position_X + Deplacement_X par Focale_Z + Position_Z + Deplacement_Z
		add eax,Largeur_Ecran_Travail_Moitiee				;; ajouter le Centre de l'axe X au rsultat en eax

		pop edx									;; dsempiler edx
		pop ecx									;; dsempiler ecx
	ret											;; retourner (sortir de la procdure)
;Label1:
;		mov eax,-1								;; placer - 1 dans eax
;		mov ebx,-1								;; placer - 1 dans ebx
;
;		pop edx									;; dsempiler edx
;		pop ecx									;; dsempiler ecx
;	ret											;; retourner (sortir de la procdure)
DefinirCoordonnees2DPoint3D ENDP


